﻿package classes.common
{
	import flash.display.Sprite;
	import flash.display.Loader;
	import flash.display.GradientType;
	import flash.display.Shape;		
	import flash.display.Graphics;
	import flash.display.Bitmap;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFieldType;
	import flash.net.URLRequest;	
	
	public class BaseButton extends Sprite
	{
	    //** static variable **//
		//Alignment for texts
		static public const ALIGN_LEFT:int = 0;
		static public const ALIGN_CENTER:int = 1;
		static public const ALIGN_RIGHT:int = 2;
		//Basic Color 0xCED7EA
		static private const BASE_BACKCOLOR_BASE:int = 0xEAE9ED;	//Base Background Color
		static private const BACK_COLOR_BASE:int = 0x425F9C;		//Basic Background Color
		static private const BACK_COLOR_BASE_OVER:int = 0x889ECC;	//Basic Background Color - Mouse Over
		static private const TEXT_COLOR_BASE:int = 0xFFFFFF;		//Basic Text Color
		static private const TEXT_COLOR_BASE_OVER:int = 0xFFFFFF;	//Basic Text Color - Mouse Over
		static private const ACT_BACK_COLOR_BASE:int = 0xEAE9ED;		//Basic Active Background Color
		static private const ACT_BACK_COLOR_BASE_OVER:int = 0xEAE9ED;	//Basic Active Background Color - Mouse Over
		static private const ACT_TEXT_COLOR_BASE:int = 0x425F9C;		//Basic Active Text Color
		static private const ACT_TEXT_COLOR_BASE_OVER:int = 0x425F9C;	//Basic Active Text Color - Mouse Over
		static private const ACT_BORDER_COLOR_BASE:int = 0x425F9C;		//Basic Active Border Color - Mouse		
		static private const ACT_BORDER_COLOR_BASE_OVER:int = 0x425F9C;	//Basic Active Border Color - Mouse			
		static private const NON_ACT_BACK_COLOR_BASE:int = 0x425F9C;		//Basic NonActive Background Color
		static private const NON_ACT_BACK_COLOR_BASE_OVER:int = 0x889ECC;	//Basic NonActive Background Color - Mouse Over
		static private const NON_ACT_TEXT_COLOR_BASE:int = 0xFFFFFF;		//Basic NonActive Text Color
		static private const NON_ACT_TEXT_COLOR_BASE_OVER:int = 0xFFFFFF;	//Basic NonActive Text Color - Mouse Over
		static private const NON_ACT_BORDER_COLOR_BASE:int = 0xFFFFFF;		//Basic NonActive Border Color - Mouse		
		static private const NON_ACT_BORDER_COLOR_BASE_OVER:int = 0x0000FF;	//Basic NonActive Border Color - Mouse		
		//Popular Color
		static private const COLOR_WHITE:int = 0xFFFFFF;
		static private const COLOR_BLACK:int = 0x000000;
		static private const COLOR_RED:int = 0xFF0000;
		static private const COLOR_BLUE:int = 0x0000FF;
		//Text Font
		static private const FONT_SIZE_BASE:int = 30;					//Font Size
		static private const FONT_TYPE_BASE:String = "Times New Roman";	//Font Type
	    //** member variable **//
		//main member
		private var m_sprite:Sprite = null;	//Main sprite
		private var m_sprTextContainer:Sprite = null;
		private var m_shpButtonShape:Shape = null;
		private var m_objTextField:TextField = null;
		private var m_BtnName:String = "";
		private var m_URLName:String = "";	
		private var m_imgBtn:Shape = null;
		private var m_imgBtnOver:Shape = null;	//for rollover
		private var m_obj:Object;
		private var m_objInputText:Object;
		private var m_objInputText_Answer:String;
		private var m_blnInputText_Answer_LowCase:Boolean;
		private var m_aryInputText:Array;
		private var m_aryInputText_Answer:Array;
		private var m_aryInputText_Answer_LowCase:Array;		
		private var m_objRelation:Object;
		private var m_aryRelation:Array;
		private var m_imgScale:Number;
		private var m_imgBtnWidth:Number;
		private var m_imgBtnHeight:Number;
		//Button Shape
		private var m_Button_Width:Number = 400;
		private var m_Button_Height:Number = 80;
		private var m_Button_RndCorner:Number = 1.0;
		//Text Format
		private var m_objTextFormat:TextFormat = null;
		//Each object color
		private var m_Back_Color:int = BACK_COLOR_BASE;
		private var m_Back_Color_Over:int = BACK_COLOR_BASE_OVER;
		private var m_Border_Color:int = BACK_COLOR_BASE;
		private var m_Border_Color_Over:int = BACK_COLOR_BASE_OVER;		
		private var m_Text_Color:int = TEXT_COLOR_BASE;
		private var m_Text_Color_Over:int = TEXT_COLOR_BASE_OVER;
		private var m_Active_Back_Color:int = ACT_BACK_COLOR_BASE;
		private var m_Active_Back_Color_Over:int = ACT_BACK_COLOR_BASE_OVER;
		private var m_Active_Text_Color:int = ACT_TEXT_COLOR_BASE;
		private var m_Active_Text_Color_Over:int = ACT_TEXT_COLOR_BASE_OVER;
		private var m_Active_Border_Color:int = ACT_BORDER_COLOR_BASE;
		private var m_Active_Border_Color_Over:int = ACT_BORDER_COLOR_BASE_OVER;
		private var m_NonActive_Back_Color:int = NON_ACT_BACK_COLOR_BASE;
		private var m_NonActive_Back_Color_Over:int = NON_ACT_BACK_COLOR_BASE_OVER;
		private var m_NonActive_Text_Color:int = NON_ACT_TEXT_COLOR_BASE;
		private var m_NonActive_Text_Color_Over:int = NON_ACT_TEXT_COLOR_BASE_OVER;
		private var m_NonActive_Border_Color:int = NON_ACT_BORDER_COLOR_BASE;
		private var m_NonActive_Border_Color_Over:int = NON_ACT_BORDER_COLOR_BASE_OVER;
		
		//--------------------------------------------------------------------------
		//  Method:CreateMenuBar
		//  Expranation: Constructor
		//	Parameter: 		---  
		//--------------------------------------------------------------------------	
		public function BaseButton(strBtnName:String)
		{
			//Set BaseInfo for Button
			btnName = strBtnName;
		}
		
		//--------------------------------------------------------------------------
		//  Method:textButton
		//  Expranation: Create text button
		//	Parameter: 	strText			:String	--- Button text
		//				numSize_Width	:Number	--- Button size
		//				numSize_Height	:Number	--- Button size
		//				strBtnName		:String --- Button name
		//				img				:Shape 	--- Button image
		//				imgrollover		:Shape 	--- Button image for rollover
		//--------------------------------------------------------------------------		
		 public function textButton(strText:String,numSize_Width:Number,numSize_Height:Number
									,asButton:Boolean=true,numFntSize:Number=FONT_SIZE_BASE,strFntType:String=FONT_TYPE_BASE
									,numRndCorner:Number=1.0):void 
		 {
			//Creat Sprite for Button
			m_sprTextContainer = new Sprite();
			m_shpButtonShape = new Shape();
			shpButtonShape.graphics.beginFill(BACK_COLOR_BASE);
			button_RndCorner = numRndCorner;
			if(button_RndCorner==1.0){shpButtonShape.graphics.drawRect(0,0,numSize_Width,numSize_Height);}
			else{shpButtonShape.graphics.drawRoundRect(0,0,numSize_Width,numSize_Height,button_RndCorner);}
			shpButtonShape.graphics.endFill();
			sprTextContainer.addChild(shpButtonShape);
			button_Width = numSize_Width;
			button_Height = numSize_Height;

			if (strText != "") 
			{
				//Set Button Format
				m_objTextField = new TextField();
				objTextField.text = strText;
				objTextField.autoSize = TextFieldAutoSize.LEFT;				
				objTextField.selectable = false;
				objTextFormat = new TextFormat();
				objTextFormat.align = TextFormatAlign.CENTER;
				objTextFormat.font = strFntType;
				objTextFormat.bold = true;
				objTextFormat.size = numFntSize;
				objTextFormat.color = TEXT_COLOR_BASE;
				objTextField.setTextFormat(objTextFormat);
				objTextField.x = (sprTextContainer.width - objTextField.width)/2;
				objTextField.y = (sprTextContainer.height - objTextField.height)/2;
				objTextField.mouseEnabled = false;
				sprTextContainer.addChild(objTextField);
				if(asButton)
				{
					sprTextContainer.addEventListener(MouseEvent.MOUSE_OVER,this.mouseOver);
					sprTextContainer.addEventListener(MouseEvent.MOUSE_OUT,this.mouseOut);
					sprTextContainer.buttonMode = true;
					sprTextContainer.useHandCursor = true;
				}
			}
			this.addChild(sprTextContainer);			
		}
		
		//--------------------------------------------------------------------------
		//  Method:textButton
		//  Expranation: Create imge button
		//	Parameter: 	strURL_Normal	:String	--- Button img URL
		//	Parameter: 	objButton		:Object	--- Button object
		//				numScale_Normal	:Number	--- Button scale
		//				asButton		:Boolean--- Work as Button or not
		//--------------------------------------------------------------------------	
		 public function imageButton(strURL_Normal:String,numScale_Normal:Number,asButton:Boolean=true):void 
		 {
			//Set BaseInfo for Button
			var sprImgBtn:Sprite = setLoadImage(strURL_Normal,0,0,numScale_Normal,true,asButton,"",null);
			this.addChild(sprImgBtn);
			imgScale = numScale_Normal;
			if(asButton)
			{
				sprImgBtn.buttonMode = true;
				sprImgBtn.useHandCursor = true;
			}
		}

		//--------------------------------------------------------------------------
		//  Method:objButton
		//  Expranation: Create object button
		//	Parameter: 	objButton		:Object	--- Button object
		//				numScale_Normal	:Number	--- Button scale
		//				asButton		:Boolean--- Work as Button or not
		//--------------------------------------------------------------------------	
		 public function objButton(objButton:Object,numScale_Normal:Number,asButton:Boolean=true):void 
		 {
			//Set BaseInfo for Button			
			var sprObjBtn:Sprite = setLoadObject(objButton,0,0,true,asButton,"",null);
			this.addChild(sprObjBtn);
			imgScale = numScale_Normal;
			if(asButton)
			{
				sprObjBtn.buttonMode = true;
				sprObjBtn.useHandCursor = true;
			}
		}
		
		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get sprite():Sprite
		{
			return m_sprite;
		}
		public function set sprite(val:Sprite):void
		{
			m_sprite = val;
		}
		
		public function get sprTextContainer():Sprite
		{
			return m_sprTextContainer;
		}
		public function set sprTextContainer(val:Sprite):void
		{
			m_sprTextContainer = val;
		}
		
		public function get shpButtonShape():Shape
		{
			return m_shpButtonShape;
		}
		public function set shpButtonShape(val:Shape):void
		{
			m_shpButtonShape = val;
		}
		
		public function get btnName():String 
		{
			return m_BtnName;
		}
		public function set btnName(val:String):void 
		{
			m_BtnName = val;
		}

		public function get URLName():String 
		{
			return m_URLName;
		}
		public function set URLName(val:String):void 
		{
			m_URLName = val;
		}
		
		public function get back_Color():int 
		{
			return m_Back_Color;
		}
		public function set back_Color(val:int):void 
		{
			m_Back_Color = val;
		}
		
		public function get back_Color_Over():int 
		{
			return m_Back_Color_Over;
		}
		public function set back_Color_Over(val:int):void 
		{
			m_Back_Color_Over = val;
		}	

		public function get border_Color():int 
		{
			return m_Border_Color;
		}
		public function set border_Color(val:int):void 
		{
			m_Border_Color = val;
		}	
		
		public function get border_Color_Over():int 
		{
			return m_Border_Color_Over;
		}
		public function set border_Color_Over(val:int):void 
		{
			m_Border_Color_Over = val;
		}	

		public function get objTextField():TextField 
		{
			return m_objTextField;
		}
		public function set objTextField(val:TextField):void 
		{
			m_objTextField = val;
		}
		
		public function get objTextFormat():TextFormat 
		{
			return m_objTextFormat;
		}
		public function set objTextFormat(val:TextFormat):void 
		{
			m_objTextFormat = val;
		}
		
		public function get text_Color():int 
		{
			return m_Text_Color;
		}
		public function set text_Color(val:int):void 
		{
			m_Text_Color = val;
		}
		
		public function get text_Color_Over():int 
		{
			return m_Text_Color_Over;
		}
		public function set text_Color_Over(val:int):void 
		{
			m_Text_Color_Over = val;
		}
		
		public function get active_Back_Color():int 
		{
			return m_Active_Back_Color;
		}
		public function set active_Back_Color(val:int):void 
		{
			m_Active_Back_Color = val;
		}
		
		public function get active_Back_Color_Over():int 
		{
			return m_Active_Back_Color_Over;
		}
		public function set active_Back_Color_Over(val:int):void 
		{
			m_Active_Back_Color_Over = val;
		}	
		
		public function get active_Text_Color():int 
		{
			return m_Active_Text_Color;
		}
		public function set active_Text_Color(val:int):void 
		{
			m_Active_Text_Color = val;
		}

		public function get active_Text_Color_Over():int 
		{
			return m_Active_Text_Color_Over;
		}
		public function set active_Text_Color_Over(val:int):void 
		{
			m_Active_Text_Color_Over = val;
		}

		public function get active_Border_Color():int 
		{
			return m_Active_Border_Color;
		}
		public function set active_Border_Color(val:int):void 
		{
			m_Active_Border_Color = val;
		}
	
		public function get active_Border_Color_Over():int 
		{
			return m_Active_Border_Color_Over;
		}
		public function set active_Border_Color_Over(val:int):void 
		{
			m_Active_Border_Color_Over = val;
		}

		public function get nonActive_Back_Color():int 
		{
			return m_NonActive_Back_Color;
		}
		public function set nonActive_Back_Color(val:int):void 
		{
			m_NonActive_Back_Color = val;
		}
		
		public function get nonActive_Back_Color_Over():int 
		{
			return m_NonActive_Back_Color_Over;
		}
		public function set nonActive_Back_Color_Over(val:int):void 
		{
			m_NonActive_Back_Color_Over = val;
		}	
		
		public function get nonActive_Text_Color():int 
		{
			return m_NonActive_Text_Color;
		}
		public function set nonActive_Text_Color(val:int):void 
		{
			m_NonActive_Text_Color = val;
		}

		public function get nonActive_Text_Color_Over():int 
		{
			return m_NonActive_Text_Color_Over;
		}
		public function set nonActive_Text_Color_Over(val:int):void 
		{
			m_NonActive_Text_Color_Over = val;
		}

		public function get nonActive_Border_Color():int 
		{
			return m_NonActive_Border_Color;
		}
		public function set nonActive_Border_Color(val:int):void 
		{
			m_NonActive_Border_Color = val;
		}
	
		public function get nonActive_Border_Color_Over():int 
		{
			return m_NonActive_Border_Color_Over;
		}
		public function set nonActive_Border_Color_Over(val:int):void 
		{
			m_NonActive_Border_Color_Over = val;
		}
		
		public function get button_Width():int 
		{
			return m_Button_Width;
		}
		public function set button_Width(val:int):void 
		{
			m_Button_Width = val;
		}
		
		public function get button_Height():int 
		{
			return m_Button_Height;
		}
		public function set button_Height(val:int):void 
		{
			m_Button_Height = val;
		}
		
		public function get button_RndCorner():Number 
		{
			return m_Button_RndCorner;
		}
		public function set button_RndCorner(val:Number):void 
		{
			m_Button_RndCorner = val;
		}

		public function get imgScale():Number 
		{
			return m_imgScale;
		}
		public function set imgScale(val:Number):void 
		{
			m_imgScale = val;
		}
		
		public function get imgBtnWidth():Number 
		{
			return m_imgBtnWidth;
		}
		public function set imgBtnWidth(val:Number):void 
		{
			m_imgBtnWidth = val;
		}

		public function get imgBtnHeight():Number 
		{
			return m_imgBtnHeight;
		}
		public function set imgBtnHeight(val:Number):void 
		{
			m_imgBtnHeight = val;
		}
		
		public function get objInputText():Object 
		{
			return m_objInputText;
		}
		public function set objInputText(val:Object):void 
		{
			m_objInputText = val;
		}
		
		public function get objInputText_Answer():String 
		{
			return m_objInputText_Answer;
		}
		public function set objInputText_Answer(val:String):void 
		{
			m_objInputText_Answer = val;
		}

		public function get blnInputText_Answer_LowCase():Boolean 
		{
			return m_blnInputText_Answer_LowCase;
		}
		public function set blnInputText_Answer_LowCase(val:Boolean):void 
		{
			m_blnInputText_Answer_LowCase = val;
		}

		public function get aryInputText():Array 
		{
			return m_aryInputText;
		}
		public function set aryInputText(val:Array):void 
		{
			m_aryInputText = val;
		}
		
		public function get aryInputText_Answer():Array 
		{
			return m_aryInputText_Answer;
		}
		public function set aryInputText_Answer(val:Array):void 
		{
			m_aryInputText_Answer = val;
		}

		public function get aryInputText_Answer_LowCase():Array 
		{
			return m_aryInputText_Answer_LowCase;
		}
		public function set aryInputText_Answer_LowCase(val:Array):void 
		{
			m_aryInputText_Answer_LowCase = val;
		}

		public function get objRelation():Object 
		{
			return m_objRelation;
		}
		public function set objRelation(val:Object):void 
		{
			m_objRelation = val;
		}

		public function get aryRelation():Array 
		{
			return m_aryRelation;
		}
		public function set aryRelation(val:Array):void 
		{
			m_aryRelation = val;
		}
		
		//--------------------------------------------------------------------------
		//  Method:btnText	---	Setter
		//  Expranation: Setter
		//	Parameter: 	strText	:String	--- Button display text
		//--------------------------------------------------------------------------
		public function set btnText(strText:String):void 
		{
			if (objTextField != null) 
			{
				objTextField.text = strText;
				objTextField.setTextFormat(objTextFormat);			
			}
		}
		//--------------------------------------------------------------------------
		//  Method:btnText	---	Getter
		//  Return:String	---	Button display text		
		//  Expranation: Getter
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------
		public function get btnText():String 
		{
			if (objTextField!=null) 
			{
				return objTextField.text;
			}
			return "";
		}
		//--------------------------------------------------------------------------
		//  Method:border	---	Setter
		//  Expranation: Setter
		//	Parameter: 	val	:Boolean	--- Border show or not
		//--------------------------------------------------------------------------
		public function set border(val:Boolean):void 
		{
			if (objTextField!=null){objTextField.border = val;}
		}

		//--------------------------------------------------------------------------
		//  Method:alignment
		//  Expranation: alignment for text
		//	Parameter: 	setValue	:int	--- Type of alignment
		//--------------------------------------------------------------------------		
		public function set alignment(setValue:int):void 
		{
			if (objTextField==null){return;}
			switch(setValue)
			{
				case ALIGN_LEFT:
					objTextFormat.align = TextFormatAlign.LEFT;
					objTextField.setTextFormat(m_objTextFormat);
					break;
				case ALIGN_CENTER:
					objTextFormat.align = TextFormatAlign.CENTER;
					objTextField.setTextFormat(m_objTextFormat);
					break;
				case ALIGN_RIGHT:
					objTextFormat.align = TextFormatAlign.RIGHT;
					objTextField.setTextFormat(m_objTextFormat);
					break;
			}
		}
		//--------------------------------------------------------------------------
		//  Method:mouseOver
		//  Expranation: Event for mouseOver
		//	Parameter: 	event	:MouseEvent	--- MouseEvent
		//--------------------------------------------------------------------------	
		public function mouseOver(event:MouseEvent):void 
		{
			if (objTextField!=null) 
			{
				objTextFormat.color = text_Color_Over;
				shpButtonShape.graphics.lineStyle(1,border_Color);
				shpButtonShape.graphics.beginFill(back_Color_Over);
				if(button_RndCorner==1.0){shpButtonShape.graphics.drawRect(0,0,button_Width,button_Height);}
				else{shpButtonShape.graphics.drawRoundRect(0,0,button_Width,button_Height,button_RndCorner);}				
				shpButtonShape.graphics.endFill();
				objTextField.setTextFormat(objTextFormat);
			}
			if (m_imgBtnOver != null){m_imgBtnOver.visible = true;}
			if (m_imgBtn != null){m_imgBtn.visible = false;}
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseOut
		//  Expranation: Event for mouseOut
		//	Parameter: 	event	:MouseEvent	--- MouseEvent
		//--------------------------------------------------------------------------
		public function mouseOut(event:MouseEvent):void
		{
			if (objTextField!=null)
			{
				objTextFormat.color = text_Color;
				shpButtonShape.graphics.lineStyle(1,border_Color);
				shpButtonShape.graphics.beginFill(back_Color);
				if(button_RndCorner==1.0){shpButtonShape.graphics.drawRect(0,0,button_Width,button_Height);}
				else{shpButtonShape.graphics.drawRoundRect(0,0,button_Width,button_Height,button_RndCorner);}
				shpButtonShape.graphics.endFill();
				objTextField.setTextFormat(objTextFormat);
			}
			if (m_imgBtn!=null){m_imgBtn.visible = true;}
			if (m_imgBtnOver!=null){m_imgBtnOver.visible = false;}
		}

		//--------------------------------------------------------------------------
		//  Method:mouseOver
		//  Expranation: Event for mouseOver
		//	Parameter: 	event	:MouseEvent	--- MouseEvent
		//--------------------------------------------------------------------------	
		public function buttonActive():void 
		{
			if (objTextField!=null) 
			{
				objTextFormat.color = active_Text_Color;
				shpButtonShape.graphics.lineStyle(1,active_Border_Color);
				shpButtonShape.graphics.beginFill(active_Back_Color);
				shpButtonShape.graphics.drawRect(0,0,button_Width,button_Height);
				shpButtonShape.graphics.endFill();
				objTextField.setTextFormat(objTextFormat);
				back_Color = active_Back_Color;
				back_Color_Over = active_Back_Color_Over;
				border_Color = active_Border_Color;
				border_Color_Over = active_Border_Color_Over;	
				text_Color = active_Text_Color;
				text_Color_Over = active_Text_Color_Over;	
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseOut
		//  Expranation: Event for mouseOut
		//	Parameter: 	event	:MouseEvent	--- MouseEvent
		//--------------------------------------------------------------------------
		public function buttonNonActive():void
		{
			if (objTextField!=null)
			{
				objTextFormat.color = nonActive_Text_Color;
				shpButtonShape.graphics.lineStyle(1,nonActive_Border_Color);
				shpButtonShape.graphics.beginFill(nonActive_Back_Color);
				shpButtonShape.graphics.drawRect(0,0,button_Width,button_Height);
				shpButtonShape.graphics.endFill();
				objTextField.setTextFormat(objTextFormat);
				back_Color = nonActive_Back_Color;
				back_Color_Over = nonActive_Back_Color_Over;
				border_Color = nonActive_Border_Color;
				border_Color_Over = nonActive_Border_Color_Over;				
				text_Color = nonActive_Text_Color;
				text_Color_Over = nonActive_Text_Color_Over;				
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:ChangeFormat_Base
		//  Expranation: Change button(Textfields) format
		//	Parameter: 	strText			:String	--- Button text
		//				numSize_Width	:int 	--- Button width
		//				numSize_Height	:int 	--- Button height
		//				intBkColor		:int 	--- Button color
		//				intBkColorOver	:int 	--- Button color rollover
		//				intTxtColor		:int	--- Text color 
		//				intTxtColorOver	:int 	--- Text color rollover
		//				strFntTyp		:String --- Fonr Type height
		//				intFntSize		:int 	--- Font size
		//--------------------------------------------------------------------------	
		public function ChangeFormat_Base(strText:String,numSize_Width:Number,numSize_Height:Number
									,intBkColor:int,intBkColorOver:int,intTxtColor:int
									,intTxtColorOver:int,intBorderColor:int,intBorderColorOver:int
									,strFntTyp:String=FONT_TYPE_BASE,intFntSize:int=30):void 
		{			
			//Change Button(textfield) Format
			shpButtonShape.graphics.lineStyle(1,intBkColor);
			shpButtonShape.graphics.beginFill(intBkColor);
			shpButtonShape.graphics.drawRect(0,0,button_Width,button_Height);
			shpButtonShape.graphics.endFill();
			objTextField.text = strText;
			objTextField.width = numSize_Width;
			objTextField.height = numSize_Height;
			objTextField.borderColor = intBorderColor;
			objTextField.backgroundColor = intBkColor;
			objTextFormat.font = strFntTyp;
			objTextFormat.size = intFntSize;
			objTextFormat.color = intTxtColor;			
			objTextField.setTextFormat(objTextFormat);
			back_Color = intBkColor;
			back_Color_Over = intBkColorOver;
			text_Color = intTxtColor;
			text_Color_Over = intTxtColorOver;
		}
		
		//--------------------------------------------------------------------------
		//  Method:ChangeFormat_NonActive
		//  Expranation: Change button(Textfields) format
		//	Parameter: 	strText			:String	--- Button text
		//				numSize_Width	:int 	--- Button width
		//				numSize_Height	:int 	--- Button height
		//				intBkColor		:int 	--- Button color
		//				intBkColorOver	:int 	--- Button color rollover
		//				intTxtColor		:int	--- Text color 
		//				intTxtColorOver	:int 	--- Text color rollover
		//				strFntTyp		:String --- Fonr Type height
		//				intFntSize		:int 	--- Font size
		//--------------------------------------------------------------------------	
		public function ChangeFormat_NonActive(strText:String,numSize_Width:Number,numSize_Height:Number
												,intBkColor:int,intBkColorOver:int,intTxtColor:int
												,intTxtColorOver:int,intBorderColor:int,intBorderColorOver:int
												,strFntTyp:String=FONT_TYPE_BASE,intFntSize:int=30):void 
		{
			//Change Button(textfield) Format
			objTextField.text = strText;
			objTextField.width = numSize_Width;
			objTextField.height = numSize_Height;
			objTextField.borderColor = intBorderColor;
			objTextField.backgroundColor = intBkColor;
			objTextFormat.font = strFntTyp;
			objTextFormat.size = intFntSize;
			objTextFormat.color = intTxtColor;
			objTextField.setTextFormat(objTextFormat);
			nonActive_Back_Color = intBkColor;
			nonActive_Back_Color_Over = intBkColorOver;
			nonActive_Text_Color = intTxtColor;
			nonActive_Text_Color_Over = intTxtColorOver;
		}
		
		//--------------------------------------------------------------------------
		//  Method:ResetFormat_Base
		//  Expranation: Reset button(Textfields) format
		//	Parameter: 	---
		//--------------------------------------------------------------------------		
		 public function ResetFormat_Base():void 
		 {
			//Set Button Format
			objTextField.border = true;
			objTextField.borderColor = BACK_COLOR_BASE;
			objTextField.background = true;
			objTextField.backgroundColor = BACK_COLOR_BASE;
			objTextField.selectable = false;
			objTextFormat.align = TextFormatAlign.LEFT;
			objTextFormat.font = FONT_TYPE_BASE;
			objTextFormat.bold = true;
			objTextFormat.size = FONT_SIZE_BASE;
			objTextFormat.color = TEXT_COLOR_BASE;
			objTextField.setTextFormat(objTextFormat);
			objTextField.mouseEnabled = false;
			back_Color = BACK_COLOR_BASE;
			back_Color_Over = BACK_COLOR_BASE_OVER;
			text_Color = TEXT_COLOR_BASE;
			text_Color_Over = TEXT_COLOR_BASE_OVER;
		}
		
		//--------------------------------------------------------------------------
		//  Method:ResetFormat_NonActive
		//  Expranation: Reset button(Textfields) format
		//	Parameter: 	---
		//--------------------------------------------------------------------------		
		 public function ResetFormat_NonActive():void 
		 {
			//Set Button Format
			objTextField.border = true;
			objTextField.borderColor = NON_ACT_BACK_COLOR_BASE;
			objTextField.background = true;
			objTextField.backgroundColor = NON_ACT_BACK_COLOR_BASE;
			objTextField.selectable = false;
			objTextFormat.align = TextFormatAlign.LEFT;
			objTextFormat.font = FONT_TYPE_BASE;
			objTextFormat.bold = true;
			objTextFormat.size = FONT_SIZE_BASE;
			objTextFormat.color = NON_ACT_TEXT_COLOR_BASE;
			objTextField.setTextFormat(objTextFormat);
			objTextField.mouseEnabled = false;
			nonActive_Back_Color = NON_ACT_BACK_COLOR_BASE;
			nonActive_Back_Color_Over = NON_ACT_BACK_COLOR_BASE_OVER;
			nonActive_Text_Color = NON_ACT_TEXT_COLOR_BASE;
			nonActive_Text_Color_Over = NON_ACT_TEXT_COLOR_BASE_OVER;
		}
		
		//--------------------------------------------------------------------------
		//  Method:setLoadImage
		//  Expranation: Load the image and set the button
		//	Parameter: 	strImgURL		:String	--- Image URL
		//				strImgName		:String	--- Image name
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale
		//				mouse_event		:String	--- Mouse event
		//				event_function	:Function	--- Mouse event function		
		//--------------------------------------------------------------------------	
		private function setLoadImage(strImgURL:String
									 ,pos_X:Number,pos_Y:Number,numScale:Number
									 ,blnVisible:Boolean,blnEnabled:Boolean,mouse_event:String
									 ,event_function:Function):Sprite
		{
			var sprImg:Sprite = new Sprite();
			var loader_Image:Loader = new Loader();
			var request_Image:URLRequest = new URLRequest(strImgURL);
			sprImg.x = pos_X;
			sprImg.y = pos_Y;
			sprImg.name = btnName;
			sprImg.buttonMode = true;
			loader_Image.contentLoaderInfo.addEventListener(Event.COMPLETE,imgSmoothing);
			loader_Image.scaleX = loader_Image.scaleY = numScale;
			loader_Image.name = "loader_Image" + btnName;
			loader_Image.mouseEnabled = false;
			sprImg.addChild(loader_Image);
			if(mouse_event!=""){sprImg.addEventListener(mouse_event,event_function)};
			m_obj = loader_Image;	//dummy
			loader_Image.load(request_Image);
			sprImg.visible = blnVisible;
			sprImg.mouseEnabled = blnEnabled;
			return sprImg;
		}

		//--------------------------------------------------------------------------
		//  Method:setLoadObject
		//  Expranation: Load the object and set the button
		//	Parameter:	objButton		:Object	--- Button Object
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale
		//				mouse_event		:String	--- Mouse event
		//				event_function	:Function	--- Mouse event function		
		//--------------------------------------------------------------------------	
		private function setLoadObject(objButton:Object,pos_X:Number,pos_Y:Number
										,blnVisible:Boolean,blnEnabled:Boolean,mouse_event:String
									 	,event_function:Function):Sprite
		{
			var sprObj:Sprite = new objButton as Sprite;
			sprObj.x = pos_X;
			sprObj.y = pos_Y;
			sprObj.name = btnName;
			sprObj.buttonMode = true;
			if(mouse_event!=""){sprObj.addEventListener(mouse_event,event_function)};
			sprObj.visible = blnVisible;
			sprObj.mouseEnabled = blnEnabled;
			return sprObj;
		}
		
		//--------------------------------------------------------------------------
		//  Method:imgSmoothing
		//  Expranation: Smoothing of the load image(Keep the quarity)
		//	Parameter: 	event		:Event
		//--------------------------------------------------------------------------
		private function imgSmoothing(event:Event):void 
		{
			Bitmap(event.target.content).smoothing = true;
			if(imgScale!=0)
			{
				m_imgBtnWidth = m_obj.content.width * imgScale;
				m_imgBtnHeight = m_obj.content.height * imgScale;
			}
			else
			{
				m_imgBtnWidth = m_obj.content.width;
				m_imgBtnHeight = m_obj.content.height;
			}
		}
		
//		//--------------------------------------------------------------------------
//		//  Method:set_Image_button
//		//  Expranation: Setting for Instruction Button
//		//	Parameter: 		---		
//		//--------------------------------------------------------------------------	
//		private function set_Image_button(objBtn:BaseButton,strName:String,pos_X:Number
//										  ,pos_Y:Number,fnc_Click:Function,objAddParent:Object):void 
//		{
//			objBtn.x = pos_X;
//			objBtn.y = pos_Y;
//			objBtn.name = strName;
//			objBtn.removeEventListener(MouseEvent.CLICK,fnc_Click);
//			objBtn.addEventListener(MouseEvent.CLICK,fnc_Click));
//			//sprParent.addChild(btnPrevious);
//			objAddParent.addChild(objBtn);
//		}
	}
}