﻿package  classes.common
{
	import flash.display.Sprite;	
	import flash.display.MovieClip;
	import classes.common.Static_Value;
	import classes.common.CreateMenuBar;
	import classes.common.CreateInstructor;
	import classes.common.Exercise;
	import classes.common.CreateFooter;
	
	public class BaseStage extends MovieClip
	{
		var m_sprMain:Sprite = new Sprite;
		var m_sprMenubar:Sprite = new Sprite;
		var m_sprExercise:Sprite = new Sprite;
		var m_sprPreNextBtn:Sprite = new Sprite;
		var m_sprFooter:Sprite = new Sprite;
		var m_objMenubar:CreateMenuBar;
		var m_objInstructor:CreateInstructor;
		var m_objExercise:Exercise;
		var m_objFooter:CreateFooter;
		
		static private const BASE_STAGE_WIDTH:Number = 800;			//Base Stage size width
		static private const BASE_STAGE_HEIGHT:Number = 480;		//Base Stage size height
		static private const BASE_BACKCOLOR_BASE:int = 0xEAE9ED;	//Base Background Color
		//static private const TEXT_COLOR_BASE:int = 0xFFFFFF;		//Basic Text Color
		
		//--------------------------------------------------------------------------
		//  Method:BaseStage
		//  Expranation: Constructor
		//	Parameter: 	---  	
		//--------------------------------------------------------------------------	
		public function BaseStage() 
		{
			sprMain.name = "Base";
			sprMain.graphics.beginFill(BASE_BACKCOLOR_BASE);
    		sprMain.graphics.drawRect(0,0,BASE_STAGE_WIDTH, BASE_STAGE_HEIGHT);
		}

		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get sprMain():Sprite
		{
			return m_sprMain;
		}
		public function set sprMain(val:Sprite):void
		{
			m_sprMain = val;
		}

		public function get sprMenubar():Sprite
		{
			return m_sprMenubar;
		}
		public function set sprMenubar(val:Sprite):void
		{
			m_sprMenubar = val;
		}

		public function get sprExercise():Sprite
		{
			return m_sprExercise;
		}
		public function set sprExercise(val:Sprite):void
		{
			m_sprExercise = val;
		}

		public function get sprPreNextBtn():Sprite
		{
			return m_sprPreNextBtn;
		}
		public function set sprPreNextBtn(val:Sprite):void
		{
			m_sprPreNextBtn = val;
		} 
		
		public function get sprFooter():Sprite
		{
			return m_sprFooter;
		}
		public function set sprFooter(val:Sprite):void
		{
			m_sprFooter = val;
		}
		
		public function get objMenubar():CreateMenuBar
		{
			return m_objMenubar;
		}
		public function set objMenubar(val:CreateMenuBar):void
		{
			m_objMenubar = val;
		}

		public function get objInstructor():CreateInstructor
		{
			return m_objInstructor;
		}
		public function set objInstructor(val:CreateInstructor):void
		{
			m_objInstructor = val;
		}
		
		public function get objExercise():Exercise
		{
			return m_objExercise;
		}
		public function set objExercise(val:Exercise):void
		{
			m_objExercise = val;
		}
		
		public function get objFooter():CreateFooter
		{
			return m_objFooter;
		}
		public function set objFooter(val:CreateFooter):void
		{
			m_objFooter = val;
		}
		
		//--------------------------------------------------------------------------
		//  Method:create_menubar
		//  Expranation: Create Common Menubar
		//	Parameter: 	txtTitle		:String	--- Display text
		//				numFontSize		:Number	--- Font Size 
		//				strReturnURL	:String	--- After Button_Back click, load the URL 
		//				strReturnCls	:String	--- After Button_Back click, return object name 
		//				objReturnCls	:Object	--- After Button_Back click, return object
		//				objAboutUs		:Object	--- After Button_About us click, show object
		//				objOther		:Object	--- After Button_About us click, show object
		//--------------------------------------------------------------------------
		public function create_menubar(txtTitle:String,numFontSize:Number,strReturnURL:String
								   		,blnReturnURL:Boolean,strReturnCls:String="",objReturnCls:Object=null):void
		{
			///**Menu Bar**///
			sprMenubar = new Sprite();
			sprMenubar.name = Static_Value.SPRITE_MENUBAR;
			sprMain.addChild(sprMenubar);
			objMenubar = new CreateMenuBar(this);
			objMenubar.setMenubar(txtTitle,numFontSize,strReturnURL
								  ,blnReturnURL,strReturnCls,objReturnCls);
		}

		//--------------------------------------------------------------------------
		//  Method:replace_menubar
		//  Expranation: Replace Common Menubar
		//	Parameter: 	txtTitle		:String	--- Display text
		//				numFontSize		:Number	--- Font Size
		//				strReturnURL	:String	--- After Button_Back click, return swf name 
		//				strReturnCls	:String	--- After Button_Back click, return object name 
		//				objReturnCls	:Object	--- After Button_Back click, return object 		
		//--------------------------------------------------------------------------
		public function replace_menubar(txtTitle:String,numFontSize:Number,strReturnURL:String
								   		,strReturnCls:String,objReturnCls:Object)
		{
			///**Replace Menu Bar**///
			objMenubar.replaceMenubar(txtTitle,numFontSize,strReturnURL,strReturnCls,objReturnCls);
		}

		//--------------------------------------------------------------------------
		//  Method:create_instructor
		//  Expranation: Create Common Instructor
		//	Parameter: 	valInstructor	:Object	--- Display Moviecrip
		//				ins_pos_X		:Number	--- Display Moviecrip position X 
		//				ins_pos_Y		:Number	--- Display Moviecrip position Y
		//				objSound		:Object	--- Instruction Sound		
		//				spk_pos_X		:Number	--- Speaker Moviecrip position X 
		//				spk_pos_Y		:Number	--- Speaker Moviecrip position Y
		//				strImgSpk		:String	--- Speaker Image URL
		//--------------------------------------------------------------------------
		public function create_instructor(valInstructor:Object,ins_pos_X:Number,ins_pos_Y:Number
									 		,objSound:Object,spk_pos_X:Number,spk_pos_Y:Number
											,strImgSpk:String="",strURLSpk:String="")
		{
			///**Instructor**///
			var sprInstructor:Sprite = new Sprite();
			sprInstructor.name = Static_Value.SPRITE_INSTRUCTOR;
			sprMain.addChild(sprInstructor);			
			objInstructor = new CreateInstructor(sprMain,sprInstructor);
			if(valInstructor!=null){objInstructor.setInstructor(valInstructor,ins_pos_X,ins_pos_Y,objSound,spk_pos_X,spk_pos_Y,strImgSpk,strURLSpk);}
		}

		//--------------------------------------------------------------------------
		//  Method:replace_instructor
		//  Expranation: Replace Common Instructor
		//	Parameter: 	valInstructor	:Object	--- Display Moviecrip
		//				ins_pos_X		:Number	--- Display Moviecrip position X 
		//				ins_pos_Y		:Number	--- Display Moviecrip position Y
		//				objSound		:Object	--- Instruction Sound		
		//				spk_pos_X		:Number	--- Speaker Moviecrip position X 
		//				spk_pos_Y		:Number	--- Speaker Moviecrip position Y		
		//--------------------------------------------------------------------------
		public function replace_instructor(valInstructor:Object,ins_pos_X:Number,ins_pos_Y:Number
									 		,objSound:Object,spk_pos_X:Number,spk_pos_Y:Number
											,strImgSpk:String="",strURLSpk:String="")
		{
			///**Delete Instructor**///
			for(var i:int=0; i<sprMain.numChildren; i++)
			{
				if(sprMain.getChildAt(i).name==Static_Value.SPRITE_INSTRUCTOR)
				{
					var obj = sprMain.getChildAt(i);
					sprMain.removeChild(obj);
					obj = null;
					break;
				}
			}
			///**Add Instructor**///
			var sprInstructor:Sprite = new Sprite();
			sprInstructor.name = Static_Value.SPRITE_INSTRUCTOR;
			sprMain.addChild(sprInstructor);			
			objInstructor = new CreateInstructor(sprMain,sprInstructor);
			//objInstructor.replaceInstructor(valInstructor,ins_pos_X,ins_pos_Y,objSound,spk_pos_X,spk_pos_Y);
			objInstructor.setInstructor(valInstructor,ins_pos_X,ins_pos_Y,objSound,spk_pos_X,spk_pos_Y,strImgSpk,strURLSpk);
		}
		
		//--------------------------------------------------------------------------
		//  Method:stop_instructor
		//  Expranation: Stop instructor sound
		//	Parameter: 	valInstructor	--- 
		//--------------------------------------------------------------------------
		public function stop_instructor()
		{
			///**Instructor**///
			objInstructor.stopSound();
		}		

		//--------------------------------------------------------------------------
		//  Method:create_prev_next_Exercise
		//  Expranation: Create main cumpus
		//	Parameter: 	intPages		:int	--- Total page
		//				strExcerciseType:String	--- Excercise Type
		//				pos_X		:Number	--- previous and next button area position X 
		//				pos_Y		:Number	--- previous and next button area position Y		
		//--------------------------------------------------------------------------
		public function create_exercise(pos_X:Number=0,pos_Y:Number=0)
		{
			///**Exercise**///
			sprExercise = new Sprite();
			sprExercise.x = pos_X;
			sprExercise.y = pos_Y;			
			sprExercise.name = Static_Value.SPRITE_EXERCISE;
			sprMain.addChild(sprExercise);
			objExercise = new Exercise(sprMain,sprExercise);
		}

		//--------------------------------------------------------------------------
		//  Method:create_prev_next
		//  Expranation: Create previous and next button area
		//	Parameter: 	intPages		:int	--- Total page
		//				strExcerciseType:String	--- Excercise Type
		//				pos_X		:Number	--- previous and next button area position X 
		//				pos_Y		:Number	--- previous and next button area position Y		
		//--------------------------------------------------------------------------
//		public function create_prev_next(intPages:int,strExcerciseType:String
//										 ,pos_X:Number=0,pos_Y:Number=650)
//		{
//			const PREVIOUS_BUTTON_BASE_X:Number = 40;
//			const PREVIOUS_BUTTON_BASE_Y:Number = 0;
//			const NEXT_BUTTON_BASE_X:Number = 392; //480-40-48
//			const NEXT_BUTTON_BASE_Y:Number = 0;			
//			///**Instructor**///
//			sprPreNextBtn = new Sprite();
//			sprPreNextBtn.x = pos_X;
//			sprPreNextBtn.y = pos_Y;			
//			sprPreNextBtn.name = "sprPreNext";
//			sprMain.addChild(sprPreNextBtn);
//			objExercise = new Exercise(sprMain,sprPreNextBtn);
//			objExercise.setExerciseInfo(intPages,strExcerciseType);
//			objExercise.setNextPrvButton(PREVIOUS_BUTTON_BASE_X,PREVIOUS_BUTTON_BASE_Y,NEXT_BUTTON_BASE_X,NEXT_BUTTON_BASE_Y);				
//		}
		
		//--------------------------------------------------------------------------
		//  Method:create_footer_activities
		//  Expranation: Create Common Footer
		//	Parameter: 	txtTitle		:String	--- Display text
		//				aryActBtnInfo	:Array	--- Activiti button detail
		//				numBase_X		:Number	--- Position X
		//--------------------------------------------------------------------------	
		public function create_footer_activities(txtTitle:String,aryActBtnInfo:Array,numBase_X:Number)
		{
			///**Footer**///
			sprFooter = new Sprite();
			sprFooter.name = Static_Value.SPRITE_FOOTER;
			sprMain.addChild(sprFooter);
			objFooter = new CreateFooter(this);
			objFooter.setFooter_Activities(txtTitle,aryActBtnInfo,numBase_X);		
		}

		//--------------------------------------------------------------------------
		//  Method:replace_footer_activities
		//  Expranation: Setting for Active-NonActiveButtons
		//	Parameter: 	intVal	:int	--- Active button No
		//				aryActBtnInfo	:Array	--- Activiti button detail
		//				numBase_X		:Number	--- Position X		
		//--------------------------------------------------------------------------	
		public function replace_footer_activities(intNo:int,aryActBtnInfo:Array=null,numBase_X:Number=0)
		{
			///**Replace Footer activities**///
			//if(aryActBtnInfo!=null){objFooter.resetActivityButton(aryActBtnInfo);}
			objFooter.setBtnActNonAct(intNo,aryActBtnInfo,numBase_X);
			sprFooter.visible = true;
		}
		
		//--------------------------------------------------------------------------
		//  Method:replace_footer_activities
		//  Expranation: Create Common Footer
		//	Parameter: 	aryActBtnInfo	:Array	--- Activiti button detail
		//				numBase_X		:Number	--- Position X
		//--------------------------------------------------------------------------	
		public function replace_footer_activities2(aryActBtnInfo:Array,numBase_X:Number)
		{
			///**Replace Footer activities**///
			objFooter.resetActivityButton(aryActBtnInfo,numBase_X);
		}
	}
	
}
