﻿package classes.common 
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.display.SimpleButton;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFormat; 
	
	public class CreateFooter 
	{
		static private const BASE_BACKCOLOR_BASE:int = 0xEAE9ED;		//Base Background Color
		static private const FOOTER_BACKCOLOR:int = 0x425F9C;			//Footer Background Color
		static private const FOOTER_BASE_X:Number = 0;					//Footer base position X
		static private const FOOTER_BASE_Y:Number = 750;//620;//450;//750;				//Footer base position Y

		static private const TEXT_COLOR_BASE:int = 0xFFFFFF;			//Basic Text Color
		//Basic Color
		static private const NON_ACT_BACK_COLOR_BASE:int = 0x425F9C;	//Basic Background Color
		//static private const BACK_COLOR_BASE_OVER:int = 0xA8EAEA;		//Basic Background Color - Mouse Over
		//static private const BACK_COLOR_BASE_OVER:int = 0xCED7EA;		//Basic Background Color - Mouse Over
		static private const NON_ACT_TEXT_COLOR_BASE:int = 0x000000;	//Basic Text Color
		//static private const TEXT_COLOR_BASE_OVER:int = 0xA49B9B;		//Basic Text Color - Mouse Over
		//static private const NON_ACT_BORDER_COLOR_BASE:int = 0x00CCFF;	//Basic Border Color - Mouse
		//static private const BORDER_COLOR_BASE_OVER:int = 0x00CCFF;		//Basic Border Color - Mouse Over
		//Popular Color
		static private const COLOR_WHITE:int = 0xFFFFFF;
		static private const COLOR_BLACK:int = 0x000000;
		static private const COLOR_RED:int = 0xFF0000;
		static private const COLOR_BLUE:int = 0x0000FF;
		//Text Font
		static private const FONT_SIZE_BASE:int = 20;					//Font Size
		static private const FONT_TYPE_BASE:String = "Tahoma";			//Font Type

		private var m_objBase:BaseStage;
		private var m_sprParent:Sprite;
		
		//--------------------------------------------------------------------------
		//  Method:CreateFooter
		//  Expranation: Constructor
		//	Parameter: 	val_sprParent		:Sprite	--- Sprite to add the footer	
		//--------------------------------------------------------------------------	
		public function CreateFooter(val_objBase:BaseStage)
		{
			this.objBase = val_objBase;
			this.sprParent = val_objBase.sprFooter;
			sprParent.x = FOOTER_BASE_X;
			sprParent.y = FOOTER_BASE_Y;
		}

		private function init()
		{
			
		}

		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get objBase():BaseStage
		{
			return m_objBase;
		}
		public function set objBase(val:BaseStage):void
		{
			m_objBase = val;
		}

		public function get sprParent():Sprite
		{
			return m_sprParent;
		}
		public function set sprParent(val:Sprite):void
		{
			m_sprParent = val;
		}
		
		//--------------------------------------------------------------------------
		//  Method:setFooter_Activities
		//  Expranation: Setting for Common Avtvity Footer
		//	Parameter: 	txtTitle		:String	--- Display text
		//				aryActBtnInfo	:Array	--- Activiti button detail
		//				numBase_X		:Number	--- Position X
		//--------------------------------------------------------------------------	
		public function setFooter_Activities(txtTitle:String,aryActBtnInfo:Array,numBase_X:Number=140):void
		{
			/**Draw rectangle**/
			createSquare();			
			/** Tittle**/
			setTextField(txtTitle,FONT_TYPE_BASE,FONT_SIZE_BASE,TEXT_COLOR_BASE,true,10,10,100);			
			/** ActivityButton **/
			setActivityButton(aryActBtnInfo,numBase_X);
		}

		//--------------------------------------------------------------------------
		//  Method:resetActivityButton
		//  Expranation: Setting for Common Avtvity Footer
		//	Parameter: 	txtTitle		:String	--- Display text
		//				aryActBtnInfo	:Array	--- Activiti button detail
		//				numBase_X		:Number	--- Position X
		//--------------------------------------------------------------------------	
		public function resetActivityButton(aryActBtnInfo:Array,numBase_X:Number=140):void
		{
			/** ActivityButton **/
			disposeActivityButton();
			setActivityButton(aryActBtnInfo,numBase_X);
		}
		
		//--------------------------------------------------------------------------
		//  Method:createSquare
		//  Expranation: Draw the sqare of menubar
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------	
		private function createSquare():void 
		{
			/**Draw rectangle**/		
			var square:Sprite = new Sprite();
			sprParent.addChildAt(square,0);
			square.graphics.lineStyle(1,FOOTER_BACKCOLOR);
			square.graphics.beginFill(FOOTER_BACKCOLOR);
			square.graphics.drawRect(0,0,479,50);
			square.graphics.endFill();
		}
		
		//--------------------------------------------------------------------------
		//  Method:setTextField
		//  Expranation: Setting for TextField of Menubar
		//	Parameter: 	strTitle		:String	--- Display text
		//				strFontTyp		:String	--- Font Type
		//				numFontSize		:Number	--- Font Size
		//				intFontColor	:int	--- Font Color
		//				blnBold			:Boolean--- Font Bold
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numWidth		:Number	--- TextField Width
		//--------------------------------------------------------------------------	
		private function setTextField(strTitle:String,strFontTyp:String,numFontSize:Number
										,intFontColor:int,blnBold:Boolean,pos_X:Number
										,pos_Y:Number,numWidth:Number):void 
		{
			/** Tittle**/
			var footerTitle:TextField = new TextField ();
			var textFormat:TextFormat = new TextFormat ();
			textFormat.font = strFontTyp;
			textFormat.size = numFontSize;			
			textFormat.color = intFontColor;
			textFormat.bold = blnBold;
			footerTitle.text = strTitle;
			footerTitle.setTextFormat(textFormat);
			footerTitle.x = pos_X;
			footerTitle.y = pos_Y;
			footerTitle.width = numWidth;
			footerTitle.name = "Title";
			sprParent.addChild(footerTitle);
		}
		
		//--------------------------------------------------------------------------
		//  Method:setActivityButton
		//  Expranation: Setting for ActivityButtons
		//	Parameter: 	aryActBtnInfo	:Array	--- Activiti button detail
		//					aryActBtnInfo[count][0]: Display Text
		//					aryActBtnInfo[count][1]: Button Name
		//					aryActBtnInfo[count][2]: Object Name
		//					aryActBtnInfo[count][3]: Class to go
		//				numBase_X		:Number	--- Position X
		//--------------------------------------------------------------------------	
		private function setActivityButton(aryActBtnInfo:Array,numBase_X:Number=140):void 
		{
			var aryActBtn:Array = [];		
			/** Button menu Activitys**/
			//for each (var item in aryActBtnInfo)
			if(aryActBtnInfo==null){return;}
			disposeActivityButton();
			for(var count:uint=0;count<aryActBtnInfo.length;count++)
			{	
				//create activity button fields//			
				aryActBtn[count] = new BaseButton(aryActBtnInfo[count][1]);
				aryActBtn[count].textButton(aryActBtnInfo[count][0],50,50);
				aryActBtn[count].name = aryActBtnInfo[count][1];
				aryActBtn[count].x = numBase_X + count*50;
				aryActBtn[count].y = 0;
				aryActBtn[count].buttonMode = true;
				if(aryActBtnInfo[count][2]!="")
				{	
					//aryActBtn[count].removeEventListener(MouseEvent.CLICK,clickActivityHandler(strReturnURL));
					var strCls:String = aryActBtnInfo[count][2];
					var objCls:Object = aryActBtnInfo[count][3];
					aryActBtn[count].buttonNonActive();
					aryActBtn[count].addEventListener(MouseEvent.CLICK,clickActivityHandler_Cls(strCls,objCls));
				}
				else
				{
					aryActBtn[count].buttonActive();
				}				
				sprParent.addChild(aryActBtn[count]);
			}
		}

		//--------------------------------------------------------------------------
		//  Method:disposeActivityButton
		//  Expranation: dispose of ActivityButtons
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------	
		private function disposeActivityButton():void 
		{
			for(var i:int=0; i<sprParent.numChildren; i++)
			{
				var nam:String = sprParent.getChildAt(i).name;
				if(nam.indexOf("btn_")!=-1)
				{
					var obj = sprParent.getChildAt(i);
					obj.removeEventListener(MouseEvent.CLICK,clickActivityHandler_Cls);
					sprParent.removeChild(obj);
					obj = null;
					i = 0;
				}		
			}
//			while(sprParent.numChildren > 0){
//				trace("disposeActivityButton:");
//				var nam:String = sprParent.getChildAt(0).name;
//				if(nam.indexOf("btn_")!=-1)
//				{
//					trace("nam:" + nam);					
//					var obj = sprParent.getChildAt(0);
//					obj.removeEventListener(MouseEvent.CLICK,clickActivityHandler_Cls);
//					sprParent.removeChild(obj);
//					obj = null;
//				}
//			}
		}

		//--------------------------------------------------------------------------
		//  Method:setBtnActNonAct
		//  Expranation: Setting for Active-NonActiveButtons
		//	Parameter: 	intVal	:int	--- Active button No
		//--------------------------------------------------------------------------	
		public function setBtnActNonAct(intVal:int,aryActBtnInfo:Array=null,numBase_X:Number=140):void 
		{
			if(aryActBtnInfo!=null)
			{
				setActivityButton(aryActBtnInfo,numBase_X);
			}
			for(var i:int=0; i<sprParent.numChildren; i++)
			{
				var obj = sprParent.getChildAt(i);
				if(obj.name.indexOf("btn_")!=-1)
				{
					obj = BaseButton(obj);
					if(obj.name.indexOf(intVal.toString())!=-1)
					{
						obj.buttonActive();
						obj.mouseEnabled = true;
					}else
					{
						obj.buttonNonActive();
						obj.mouseEnabled = false;
					}
				}		
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:buttonActive
		//  Expranation: Setting for TextField of Menubar
		//	Parameter: 	btnTarget		:BaseButton	--- Display text
		//--------------------------------------------------------------------------	
		private function buttonActive(btnTarget:BaseButton):void 
		{
			/** Color Reset **/
			btnTarget.ResetFormat_Base();
		}
	
		//--------------------------------------------------------------------------
		//  Method:buttonActive
		//  Expranation: Setting for TextField of Menubar
		//	Parameter: 	strTitle		:String	--- Display text
		//--------------------------------------------------------------------------	
		private function buttonNonActive(btnTarget:BaseButton):void 
		{
			/** Color Change **/
			btnTarget.back_Color = NON_ACT_BACK_COLOR_BASE;
			btnTarget.text_Color = NON_ACT_TEXT_COLOR_BASE;
			btnTarget.border_Color = NON_ACT_TEXT_COLOR_BASE;
		}
		
		//--------------------------------------------------------------------------
		//  Method:clickActivityHandler
		//  Expranation: EventHandler to click the button
		//	Parameter: 	strReturnURL	:String	--- After Button_Back click, load the URL 		
		//--------------------------------------------------------------------------		
		public function clickActivityHandler(strReturnURL:String):Function{
			return function(event:Event):void{
				var sprMenuBar:Sprite = m_sprParent;
				var objURL:URLRequest = new URLRequest(strReturnURL)
				var objLoader:Loader = new Loader();
				var sprMain:Sprite = sprMenuBar.parent;
				sprMain.visible = false;
				objLoader.load(objURL);
				sprMain.parent.addChild(objLoader);
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:clickActivityHandler_Cls
		//  Expranation: EventHandler to click the button
		//	Parameter: 	strReturnURL	:String	--- After Button_Back click, load the URL 		
		//--------------------------------------------------------------------------		
//		public function clickActivityHandler_Cls(strCls:String,objCls:Object):Function{
//			return function(event:Event):void{
//				var obj = sprParent.parent;
//				obj = obj.parent;
//				if(strCls!="")
//				{	
//					var sprExercise:Sprite = obj.parent;
//					obj.parent.removeChild(obj);
//				}
//				var objRequest = new objCls;
//				objRequest.name = strCls;
//				for(var i:int=0; i<sprExercise.numChildren; i++)
//				{
//					if(sprExercise.getChildAt(i).name==strCls){sprExercise.removeChild(sprExercise.getChildAt(i));}
//				}				
//				sprExercise.addChild(objRequest);
//				sprExercise.setChildIndex(objRequest,sprExercise.numChildren-1);	//move front
//			}
//		}
		public function clickActivityHandler_Cls(strCls:String,objCls:Object):Function{
			return function(event:Event):void{
				if(strCls!="" && objCls!=null)
				{
					//-- Create New class object --//
					var objRequest = new objCls;
					objRequest.name = strCls;
					//-- Delete Slider --//
					for(var i:int=0; i<objBase.sprMain.numChildren; i++)
					{
						var objSld = objBase.sprMain.getChildAt(i);
						if(objSld.name==Static_Value.SPRITE_SLIDER)
						{
							/** Delete Slider Object **/
							while(objSld.numChildren > 0)
							{
								var obj = objSld.getChildAt(0);
								objSld.removeChild(obj);
								obj = null;
							}
							objBase.sprMain.removeChild(objSld);
							break;
						}
					}
					//--- Show Footer Activity ---//
					objBase.sprFooter.visible = true;
					//--- Delete Exercise ---//
					while(objBase.sprExercise.numChildren > 0)
					{
						var objEx = objBase.sprExercise.getChildAt(0);
						objBase.sprExercise.removeChild(objEx);
						objEx = null;
					}
					objBase.sprExercise.addChild(objRequest);
					//-- Initialize of new class object --//
					objRequest.objBase = objBase;					
					objRequest.init();				
				}
			}
		}		
	}
}	