﻿package classes.common 
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Loader;
	import flash.display.SimpleButton;
	import flash.display.Bitmap;	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.IOErrorEvent;
	import flash.events.ProgressEvent;
	import flash.events.EventDispatcher;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundLoaderContext;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	import flash.text.TextFormat;
	import classes.common.BaseButton;	
	
	public class CreateInstructor 
	{
		public static var isPlaying:Boolean = false;
		
		private var m_sprBase:Sprite;
		private var m_sprParent:Sprite;
		private var m_sprExercise:Sprite;
		private var m_sprLoadBar:Sprite;
		private var m_mcInstructor:MovieClip;
		private var m_btnSpeaker:BaseButton;
		private var m_btnInstructor:BaseButton;
		private var m_sndSpeaker:Sound;
		private var m_strSound:String;
		private var m_sndLength:Number = 0;
		private var m_sndChannel:SoundChannel;
		private var m_objLoadSound:Sound;
		private var m_strLoadSound:String;
		private var m_loadSoundLength:Number = 0;
		private var m_numSndPosition:Number = 0;
		private var m_btnCorrect:BaseButton;
		private var m_sndCorrect:Sound;
		private var m_btnIncorrect:BaseButton;
		private var m_sndIncorrect:Sound;
		private var m_btnIncorrectSpell:BaseButton;
		private var m_blnResultImg:Boolean = false;
		private var m_blnResultSnd:Boolean = false;
		
		private var m_opened:Boolean = false;
		
		static private const BASE_BACKCOLOR_BASE:int = 0xEAE9ED;	//Base Background Color
		static private const MENUBAR_BACKCOLOR:int = 0x425F9C;		//Menubar Background Color
		static private const TEXT_COLOR_BASE:int = 0xFFFFFF;		//Basic Text Color
		static private const DIALOG_BACKCOLOR:int = 0xFFFFFF;		//Dialog Background Color
		static private const INSTRUCTOR_IMAGE:String = "image/Icons/parrot.png";
		static private const INSTRUCTOR_NAME:String = "Instructor";
		static private const SPEAKER_IMAGE:String = "image/Icons/speaker_instructor.png";
		static private const SPEAKER_NAME:String = "Btn_Speaker";
	
		static private const INSTRUCTOR_RESPONSE_IMAGE_CORRECT:String = "image/common/correct.png";
		static private const INSTRUCTOR_RESPONSE_NAME_CORRECT:String = "Correct";
		static private const INSTRUCTOR_RESPONSE_SOUND_CORRECT:String = "sound/common/correct.mp3";
		static private const INSTRUCTOR_RESPONSE_IMAGE_INCORRECT:String = "image/common/incorrect.png";
		static private const INSTRUCTOR_RESPONSE_NAME_INCORRECT:String = "Incorrect";
		static private const INSTRUCTOR_RESPONSE_IMAGE_INCORRECT_SPELL:String = "image/common/incorrect_spell.png";
		static private const INSTRUCTOR_RESPONSE_NAME_INCORRECT_SPELL:String = "Incorrect_Spell";	
		static private const INSTRUCTOR_RESPONSE_SOUND_INCORRECT:String = "sound/common/incorrect.mp3";
		
		//--------------------------------------------------------------------------
		//  Method:CreateInstructor
		//  Expranation: CreateInstructor
		//	Parameter: 	val_sprBase			:Sprite	--- Sprite of Base
		//				val_sprParent		:Sprite	--- Sprite to add the Instructor 
		//--------------------------------------------------------------------------	
		public function CreateInstructor(val_sprBase:Sprite,val_sprParent:Sprite)
		{
			this.sprBase = val_sprBase;
			this.sprParent = val_sprParent;
			//sprParent.x = 0;
			//sprParent.y = 0;
		}
		
		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get sprBase():Sprite
		{
			return m_sprBase;
		}
		public function set sprBase(val:Sprite):void
		{
			m_sprBase = val;
		}
		
		public function get sprParent():Sprite
		{
			return m_sprParent;
		}
		public function set sprParent(val:Sprite):void
		{
			m_sprParent = val;
		}

		public function get sprExercise():Sprite
		{
			return m_sprExercise;
		}
		public function set sprExercise(val:Sprite):void
		{
			m_sprExercise = val;
		}
		
		public function get sprLoadBar():Sprite
		{
			return m_sprLoadBar;
		}
		public function set sprLoadBar(val:Sprite):void
		{
			m_sprLoadBar = val;
		}
		
		public function get mcInstructor():MovieClip
		{
			return m_mcInstructor;
		}		
		public function set mcInstructor(val:MovieClip):void
		{
			m_mcInstructor = val;
		}
		
		public function get btnSpeaker():BaseButton
		{
			return m_btnSpeaker;
		}		
		public function set btnSpeaker(val:BaseButton):void
		{
			m_btnSpeaker = val;
		}

		public function get btnInstructor():BaseButton
		{
			return m_btnInstructor;
		}		
		public function set btnInstructor(val:BaseButton):void
		{
			m_btnInstructor = val;
		}
		
		public function get sndSpeaker():Sound
		{
			return m_sndSpeaker;
		}		
		public function set sndSpeaker(val:Sound):void
		{
			m_sndSpeaker = val;
		}

		public function get strSound():String
		{
			return m_strSound;
		}		
		public function set strSound(val:String):void
		{
			m_strSound = val;
		}
		
		public function get objLoadSound():Sound
		{
			return m_objLoadSound;
		}		
		public function set objLoadSound(val:Sound):void
		{
			m_objLoadSound = val;
		}

		public function get strLoadSound():String
		{
			return m_strLoadSound;
		}		
		public function set strLoadSound(val:String):void
		{
			m_strLoadSound = val;
		}		
		
		public function get numSndPosition():Number
		{
			return m_numSndPosition;
		}		
		public function set numSndPosition(val:Number):void
		{
			m_numSndPosition = val;
		}		

		public function get sndChannel():SoundChannel
		{
			return m_sndChannel;
		}		
		public function set sndChannel(val:SoundChannel):void
		{
			m_sndChannel = val;
		}

		public function get sndLength():Number
		{
			return m_sndLength;
		}		
		public function set sndLength(val:Number):void
		{
			m_sndLength = val;
		}		

		public function get loadSoundLength():Number
		{
			return m_loadSoundLength;
		}		
		public function set loadSoundLength(val:Number):void
		{
			m_loadSoundLength = val;
		}

		public function get blnResultImg():Boolean
		{
			return m_blnResultImg;
		}		
		public function set blnResultImg(val:Boolean):void
		{
			m_blnResultImg = val;
		}

		public function get blnResultSnd():Boolean
		{
			return m_blnResultSnd;
		}		
		public function set blnResultSnd(val:Boolean):void
		{
			m_blnResultSnd = val;
		}

		public function get btnCorrect():BaseButton
		{
			return m_btnCorrect;
		}
		public function set btnCorrect(val:BaseButton):void
		{
			m_btnCorrect = val;
		}

		public function get btnIncorrect():BaseButton
		{
			return m_btnIncorrect;
		}
		public function set btnIncorrect(val:BaseButton):void
		{
			m_btnIncorrect = val;
		}		
		
		public function get btnIncorrectSpell():BaseButton
		{
			return m_btnIncorrectSpell;
		}
		public function set btnIncorrectSpell(val:BaseButton):void
		{
			m_btnIncorrectSpell = val;
		}
		
		public function get sndCorrect():Sound
		{
			return m_sndCorrect;
		}
		public function set sndCorrect(val:Sound):void
		{
			m_sndCorrect = val;
		}

		public function get sndIncorrect():Sound
		{
			return m_sndIncorrect;
		}
		public function set sndIncorrect(val:Sound):void
		{
			m_sndIncorrect = val;
		}		
		
		//--------------------------------------------------------------------------
		//  Method:setInstructor
		//  Expranation: Setting for Instructor
		//	Parameter: 	objInstructor	:Object	--- Display text
		//				ins_pos_X		:Number	--- Position X 
		//				ins_pos_X		:Number	--- Position X 
		//				valSound		:Object	--- Sound object 		
		//				spk_pos_X		:Number	--- Position X 
		//				spk_pos_Y		:Number	--- Position X
		//				strImgSpk		:String	--- Speaker Image
		//				strURLSpk		:String	--- Speaker Sound URL		
		//--------------------------------------------------------------------------	
		public function setInstructor(objInstructor:Object,ins_pos_X:Number,ins_pos_Y:Number
									 ,valSound:Object,spk_pos_X:Number,spk_pos_Y:Number
									 ,strImgSpk:String="",strURLSpk:String=""):void
		{
			if(valSound==null && strURLSpk=="")
			{	/** Instructor without sound **/
				this.mcInstructor = new objInstructor as MovieClip;
				setInstructorImage(INSTRUCTOR_NAME,ins_pos_X,ins_pos_Y,sndSpeaker);			
			}
			else
			{
				if(strImgSpk!=""){setSpeakerImage(strImgSpk,SPEAKER_NAME,spk_pos_X,spk_pos_Y,0.6);}
				else
				{
					this.btnInstructor = new BaseButton(INSTRUCTOR_NAME);
					setInstructorButton(objInstructor,ins_pos_X,ins_pos_Y,1.0)
				}
				if(valSound!=null){this.sndSpeaker = new valSound as Sound;}
				else if(strURLSpk!=""){setSpeakerSound(strURLSpk,"Sound_" + SPEAKER_NAME);}
			}
		}

		//--------------------------------------------------------------------------
		//  Method:setInstructorImage
		//  Expranation: Setting for Instructor
		//	Parameter: 	strImgName		:String	--- Instructor name
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//--------------------------------------------------------------------------	
		private function setInstructorImage(strImgName:String,pos_X:Number,pos_Y:Number
											,sndSpeaker:Sound):void 
		{
			mcInstructor.x = pos_X;
			mcInstructor.y = pos_Y;
			mcInstructor.name = strImgName;
			sprParent.addChild(mcInstructor);
		}
		
		//--------------------------------------------------------------------------
		//  Method:setInstructorButton
		//  Expranation: Setting for Instructor
		//	Parameter: 	strImgName		:String	--- Instructor name
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Object Scale
		//--------------------------------------------------------------------------	
		private function setInstructorButton(objInstructor:Object,pos_X:Number,pos_Y:Number
											,numScale:Number):void 
		{
			btnInstructor.objButton(objInstructor,numScale);
			btnInstructor.x = pos_X;
			btnInstructor.y = pos_Y;
			btnInstructor.addEventListener(MouseEvent.CLICK,clickSpeakerHandler);
			sprParent.addChild(btnInstructor);			
		}				
		//--------------------------------------------------------------------------
		//  Method:setSpeakerImage
		//  Expranation: Setting for Button of Menubar
		//	Parameter: 	strImgURL		:String	--- Image URL
		//				strImgName		:String	--- Image name
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale		
		//--------------------------------------------------------------------------	
		private function setSpeakerImage(strImgURL:String,strImgName:String,pos_X:Number
											,pos_Y:Number,numScale:Number):void 
		{
			btnSpeaker = new BaseButton(strImgName);
			btnSpeaker.imageButton(strImgURL,numScale);
			btnSpeaker.x = pos_X;
			btnSpeaker.y = pos_Y;
			btnSpeaker.name = strImgName;
			btnSpeaker.addEventListener(MouseEvent.CLICK,clickSpeakerHandler);
			sprParent.addChild(btnSpeaker);
		}
		
		//--------------------------------------------------------------------------
		//  Method:setSpeakerSound
		//  Expranation: Setting for sound of speaker
		//	Parameter: 	strSndURL		:String	--- Sound URL
		//				strSndName		:String	--- Sound name
		//--------------------------------------------------------------------------	
		private function setSpeakerSound(strSndURL:String,strSndName:String):void 
		{
			sndSpeaker = setLoadSound(strSndURL,strSndName);
			//sprParent.addChild(sndSpeaker);
		}
		
		//--------------------------------------------------------------------------
		//  Method:imgSmoothing
		//  Expranation: Smoothing of the load image(Keep the quarity)
		//	Parameter: 	event		:Event
		//--------------------------------------------------------------------------
		private function imgSmoothing(event:Event):void 
		{
			Bitmap(event.target.content).smoothing = true;
		}
		
		//--------------------------------------------------------------------------
		//  Method:clickSpeakerHandler
		//  Expranation: EventHandler to click the button
		//	Parameter: 	strReturnURL	:String	--- After Button_Back click, load the URL 		
		//--------------------------------------------------------------------------		
		public function clickSpeakerHandler(event:Event)
		{
			if(!isPlaying) 
			{
				if(sndSpeaker!=null)
				{
					isPlaying = true;
					sndChannel = sndSpeaker.play(0);
					//this.removeEventListener(Event.ENTER_FRAME,updateSpeakerAlpha,false,0,true);
					//addEventListener(Event.ENTER_FRAME,updateSpeakerAlpha,false,0,true);
					sndChannel.addEventListener(Event.SOUND_COMPLETE,onPlayComplete,false,0,true);
				}
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:onPlayProgress
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------	
		private function onPlayProgress(event:Event):void 
		{
/*			trace("OK");
			updateSpeakerAlpha;*/
		}
		
		//--------------------------------------------------------------------------
		//  Method:onPlayComplete
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------	
		private function onPlayComplete(event:Event):void 
		{
			sndChannel.removeEventListener(Event.SOUND_COMPLETE,onPlayComplete);
			sndChannel.stop();
			numSndPosition = 0;
			isPlaying = false;
		}
		
		//--------------------------------------------------------------------------
		//  Method:setBasicInstructor_Response
		//  Expranation: Setting for correct and incorrect message
		//	Parameter: 		---		
		//--------------------------------------------------------------------------	
		public function setBasicInstructor_Response():void 
		{
			setCorrectImage(INSTRUCTOR_RESPONSE_IMAGE_CORRECT,INSTRUCTOR_RESPONSE_NAME_CORRECT,0,0,1.0);
			setCorrectSound(INSTRUCTOR_RESPONSE_SOUND_CORRECT,"Sound_" + INSTRUCTOR_RESPONSE_NAME_CORRECT);
			setIncorrectImage(INSTRUCTOR_RESPONSE_IMAGE_INCORRECT,INSTRUCTOR_RESPONSE_NAME_INCORRECT,0,0,1.0);		
			setIncorrectSound(INSTRUCTOR_RESPONSE_SOUND_INCORRECT,"Sound_" + INSTRUCTOR_RESPONSE_NAME_INCORRECT);
			//setIncorrectSpellImage(INSTRUCTOR_RESPONSE_IMAGE_INCORRECT_SPELL,INSTRUCTOR_RESPONSE_NAME_INCORRECT_SPELL,0,0,0.6);
		}		
		
		//--------------------------------------------------------------------------
		//  Method:setMsg_CorrectIncorrect
		//  Expranation: Setting for correct and incorrect message
		//	Parameter: 		---		
		//--------------------------------------------------------------------------	
		public function setMsg_CorrectIncorrect(objCorrect:Object,objIncorrect:Object)
		{
			this.btnCorrect = objCorrect();
			this.btnIncorrect = objIncorrect();		
		}
		
		//--------------------------------------------------------------------------
		//  Method:showMsg
		//  Expranation: Setting for correct message
		//	Parameter: 	blnCorrect		:Boolean	--- true:correct, false:incorrect
		//				blnSound		:Boolean	--- true:sound on, false:sound off
		//--------------------------------------------------------------------------	
//		public function showMsg(blnCorrect:Boolean,blnSound:Boolean):void 
//		{
//			if(blnCorrect)
//			{
//				this.sprBase.setChildIndex(btnCorrect,this.sprBase.numChildren-1);
//				btnCorrect.visible = true;
////				btnCorrect.addEventListener(Event.ADDED_TO_STAGE,onAddedToStage);
////				btnCorrect.addEventListener(Event.REMOVED_FROM_STAGE,onRemovedFromStage);
////				btnCorrect.addEventListener(MouseEvent.CLICK,onClickBtnOk);
//				
//				if(blnSound){playSound_Correct();}
//			}
//			else
//			{
//				btnIncorrect.visible = true;
//				if(blnSound){playSound_Incorrect();}				
//			}
//		}
		
		//--------------------------------------------------------------------------
		//  Method:setCorrectImage
		//  Expranation: Setting for Button of Menubar
		//	Parameter: 	strImgURL		:String	--- Image URL
		//				strImgName		:String	--- Image name
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale		
		//--------------------------------------------------------------------------	
		private function setCorrectImage(strImgURL:String,strImgName:String,pos_X:Number
											,pos_Y:Number,numScale:Number):void 
		{
			btnCorrect = new BaseButton(strImgName);
			btnCorrect.imageButton(strImgURL,numScale);
			btnCorrect.x = pos_X;
			btnCorrect.y = pos_Y;
			btnCorrect.name = strImgName;
			btnCorrect.visible = false;
			btnCorrect.addEventListener(MouseEvent.CLICK,clickCorrectHandler);
			//sprParent.addChild(btnCorrect);
			sprBase.addChild(btnCorrect);
		}
		
		//--------------------------------------------------------------------------
		//  Method:setCorrectSound
		//  Expranation: Setting for sound of speaker
		//	Parameter: 	strSndURL		:String	--- Sound URL
		//				strSndName		:String	--- Sound name
		//--------------------------------------------------------------------------	
		private function setCorrectSound(strSndURL:String,strSndName:String):void 
		{
			sndCorrect = setLoadSound(strSndURL,strSndName);
			//sprParent.addChild(sndCorrect);
		}

		//--------------------------------------------------------------------------
		//  Method:setIncorrectImage
		//  Expranation: Setting for Button of Menubar
		//	Parameter: 	strImgURL		:String	--- Image URL
		//				strImgName		:String	--- Image name
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale		
		//--------------------------------------------------------------------------	
		private function setIncorrectImage(strImgURL:String,strImgName:String,pos_X:Number
											,pos_Y:Number,numScale:Number):void 
		{
			btnIncorrect = new BaseButton(strImgName);
			btnIncorrect.imageButton(strImgURL,numScale);
			btnIncorrect.x = pos_X;
			btnIncorrect.y = pos_Y;
			btnIncorrect.name = strImgName;
			btnIncorrect.visible = false;
			btnIncorrect.addEventListener(MouseEvent.CLICK,clickIncorrectHandler);
			//sprParent.addChild(btnIncorrect);
			sprBase.addChild(btnIncorrect);
		}
		
		//--------------------------------------------------------------------------
		//  Method:setIncorrectSound
		//  Expranation: Setting for sound of speaker
		//	Parameter: 	strSndURL		:String	--- Sound URL
		//				strSndName		:String	--- Sound name
		//--------------------------------------------------------------------------	
		private function setIncorrectSound(strSndURL:String,strSndName:String):void 
		{
			sndIncorrect = setLoadSound(strSndURL,strSndName);
			//sprParent.addChild(sndIncorrect);
		}

		//--------------------------------------------------------------------------
		//  Method:setIncorrectSpellImage
		//  Expranation: Setting for Button of Menubar
		//	Parameter: 	strImgURL		:String	--- Image URL
		//				strImgName		:String	--- Image name
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale		
		//--------------------------------------------------------------------------	
		private function setIncorrectSpellImage(strImgURL:String,strImgName:String,pos_X:Number
												,pos_Y:Number,numScale:Number):void 
		{
			btnIncorrectSpell = new BaseButton(strImgName);
			btnIncorrectSpell.imageButton(strImgURL,numScale);
			btnIncorrectSpell.x = pos_X;
			btnIncorrectSpell.y = pos_Y;
			btnIncorrectSpell.name = strImgName;
			btnIncorrectSpell.visible = false;
			btnIncorrectSpell.addEventListener(MouseEvent.CLICK,clickIncorrectHandler);
			sprBase.addChild(btnIncorrectSpell);
		}
		
		//--------------------------------------------------------------------------
		//  Method:clickSpeakerHandler
		//  Expranation: EventHandler to click the button
		//	Parameter: 	strReturnURL	:String	--- After Button_Back click, load the URL 		
		//--------------------------------------------------------------------------		
		public function playSound_Correct()
		{
			if(!isPlaying) 
			{
				if(sndCorrect!=null)
				{
					isPlaying = true;
					sndChannel = sndCorrect.play(0);
					sndChannel.addEventListener(Event.SOUND_COMPLETE,onPlayComplete,false,0,true);
				}
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:clickSpeakerHandler
		//  Expranation: EventHandler to click the button
		//	Parameter: 	strReturnURL	:String	--- After Button_Back click, load the URL 		
		//--------------------------------------------------------------------------		
		public function playSound_Incorrect()
		{
			if(!isPlaying) 
			{
				if(sndIncorrect!=null)
				{
					isPlaying = true;
					sndChannel = sndIncorrect.play(0);
					sndChannel.addEventListener(Event.SOUND_COMPLETE,onPlayComplete,false,0,true);
				}
			}
		}
		//--------------------------------------------------------------------------
		//  Method:clickActivityHandler
		//  Expranation: EventHandler to click the button
		//	Parameter: 	strReturnURL	:String	--- After Button_Back click, load the URL 		
		//--------------------------------------------------------------------------
		private function clickCorrectHandler(event:Event):void
		{
			var objTarget = event.target;
			stopSound();
			objTarget.parent.visible = false;
		}	

		private function clickCorrectHandler2(objCurrent:Object=null,objNext:Object=null):Function{
			return function(event:Event):void{
				var objTarget = event.target;
				stopSound();
				objTarget.visible = false;
				trace("objTarget.name" + objTarget.name);
				if(objCurrent!=null){objCurrent.visible = false;}
				if(objNext!=null){objNext.visible = true;}
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:clickIncorrectHandler
		//  Expranation: EventHandler to click the button
		//	Parameter: 	event		:Event	--- 
		//--------------------------------------------------------------------------		
		private function clickIncorrectHandler(event:Event):void
		{
			var objTarget = event.target;
			stopSound();
			objTarget.parent.visible = false;
		}

		//--------------------------------------------------------------------------
		//  Method:setLoadImage
		//  Expranation: Load the image and set the button
		//	Parameter: 	strImgURL		:String	--- Image URL
		//				strImgName		:String	--- Image name
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale
		//				mouse_event		:String	--- Mouse event
		//				event_function	:Function	--- Mouse event function		
		//--------------------------------------------------------------------------	
		public function setLoadImage(strImgURL:String,strImgName:String
									 ,pos_X:Number,pos_Y:Number,numScale:Number
									 ,blnVisible:Boolean,mouse_event:String,event_function:Function):Sprite 
		{
			var sprImg:Sprite = new Sprite();
			var loader_Image:Loader = new Loader();
			var request_Image:URLRequest = new URLRequest(strImgURL);
			//sndLength = objSound.length;
			sprImg.x = pos_X;
			sprImg.y = pos_Y;
			sprImg.name = strImgName;
			sprImg.buttonMode = true;
			loader_Image.contentLoaderInfo.addEventListener(Event.COMPLETE,imgSmoothing);
			loader_Image.scaleX = loader_Image.scaleY = numScale;
			sprImg.addChild(loader_Image);
			sprImg.addEventListener(mouse_event,event_function);
			loader_Image.load(request_Image);
			sprImg.visible = blnVisible;
			return sprImg;
		}
		
		//--------------------------------------------------------------------------
		//  Method:setLoadSound
		//  Expranation: Setting for Button of Menubar
		//	Parameter: 	parentSound		:Object	--- paretn object of sound
		//				strSndURL		:String	--- Sound URL
		//				strSndName		:String	--- Sound object name
		//--------------------------------------------------------------------------	
		public function setLoadSound(strSndURL:String,strSndName:String):Sound 
		{
			var sndLoad = new Sound();
			var context:SoundLoaderContext = new SoundLoaderContext(5000);
			var request_Sound:URLRequest = new URLRequest(strSndURL);
			//track loading progress
			//sprLoadBar = drawBar(0x000099);
			//sprLoadBar.x = 20;
			//sprLoadBar.y = 15;
			//sprParent.addChild(sprLoadBar);			
			sndLoad.load(request_Sound,context);
			sndLoad.addEventListener(IOErrorEvent.IO_ERROR,onIOError,false,0,true);
			//sndLoad.addEventListener(ProgressEvent.PROGRESS,onLoadingProgress,false,0,true);
			sndLoad.addEventListener(Event.COMPLETE,onCompleteLoad,false,0,true);
			objLoadSound = sndLoad;
			return sndLoad;
		}
		
		//--------------------------------------------------------------------------
		//  Method:onIOError
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------			
		private function onIOError(event:IOErrorEvent):void {
			trace("Error occurred when loading sound:", event.text);
		}

		//--------------------------------------------------------------------------
		//  Method:drawBar
		//  Expranation: Event
		//	Parameter: 	col		:uint	---  		
		//--------------------------------------------------------------------------
		private function drawBar(col:uint):Sprite 
		{
			var sprBar:Sprite = new Sprite();
			sprBar.graphics.beginFill(col,1);
			sprBar.graphics.drawRect(0,0,1,10);
			sprBar.graphics.endFill();			
			return sprBar;
		}

		//--------------------------------------------------------------------------
		//  Method:onLoadingProgress
		//  Expranation: Event
		//	Parameter: 	event		:ProgressEvent	---  		
		//--------------------------------------------------------------------------
		private function onLoadingProgress(event:ProgressEvent):void 
		{
			sprLoadBar.width = 100 * (event.bytesLoaded / event.bytesTotal);
		}

		//--------------------------------------------------------------------------
		//  Method:onCompleteLoad
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------
		private function onCompleteLoad(event:Event):void 
		{
			loadSoundLength = objLoadSound.length;
			//trace("Sound length:", loadSoundLength);
		}
		
		//--------------------------------------------------------------------------
		//  Method:setButtonImage
		//  Expranation: Setting for Button of Menubar
		//	Parameter: 	strImgURL		:String	--- Display text
		//				strImgName		:String	--- Font Type
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale
		//				strRtnURL		:String	--- Return URL
		//				objDisplay		:Object	--- Display Object		
		//--------------------------------------------------------------------------	
		private function setButtonImage(strImgURL:String,strImgName:String,pos_X:Number
										,pos_Y:Number,numScale:Number,strRtnURL:String
										,objDialog:Object):BaseButton 
		{
			var sprBtn:BaseButton = new BaseButton(strImgName);
			sprBtn.imageButton(strImgURL,numScale);
			sprBtn.x = pos_X;
			sprBtn.y = pos_Y;
			sprBtn.name = strImgName;
			sprBtn.removeEventListener(MouseEvent.CLICK,mouseClick(strRtnURL,objDialog));
			sprBtn.addEventListener(MouseEvent.CLICK,mouseClick(strRtnURL,objDialog));
			sprParent.addChild(sprBtn);
			return sprBtn;
		}

		//--------------------------------------------------------------------------
		//  Method:setDialog
		//  Expranation: Setting for Dialog box
		//	Parameter: 	strTxt			:String	--- Display text
		//				strTxtURL		:String	--- Display text from URL
		//				strDialogName	:String	--- Dialog name
		//				txtFormat		:TextFormat	--- Text format		
		//				numTxt_Width	:Number	--- Dialog Width
		//				numTxt_Height	:Number	--- Dialog Height
		//--------------------------------------------------------------------------	
		public function setDialog(strTxt:String,strTxtURL:String,strDialogName:String
								   ,txtFormat:TextFormat,numTxt_Width:Number,numTxt_Height:Number):Object 
		{	
			//set text
			if(strTxt!="" || strTxtURL!="")
			{
				var objText = new Exercise_Text(sprBase,sprParent);
				if(strTxt!="")
				{
					objText.setExercise_Make("",strTxt,strDialogName
											 ,txtFormat,0,0
											 ,numTxt_Width,numTxt_Height,0
											 ,DIALOG_BACKCOLOR,txtFormat.color);
				}else
				{
					objText.setExercise_Make(strTxtURL,"",strDialogName
											,txtFormat,0,0
										 	,numTxt_Width,numTxt_Height,0
											,DIALOG_BACKCOLOR,txtFormat.color);
				}
			}
			//Basic setting
			var objDialog = objText.objScript;
			objDialog.x = (sprBase.width - objDialog.width)/2;
			objDialog.y = 0;
			objDialog.name = strDialogName;
			objDialog.visible = false;
			//Button Close
			var tmp_W:Number = objDialog.width;
			var tmp_H:Number = objDialog.height;
			var btnClose:BaseButton = new BaseButton("Close");
			btnClose.textButton("Close",120,40,true,24,Static_Value.FONT_TYPE_BASE);
			btnClose.x = tmp_W - 200;
			btnClose.y = tmp_H - 100;
			btnClose.name = "Btn_close";
			btnClose.removeEventListener(MouseEvent.CLICK,closeDialogClick(objDialog));
			btnClose.addEventListener(MouseEvent.CLICK,closeDialogClick(objDialog));
			objDialog.addChild(btnClose);
			//Add script in Sprite
			//sprParent.addChild(objDialog);
			return objDialog;
		}
		
		//--------------------------------------------------------------------------
		//  Method:closeDialogClick
		//  Expranation: mouse Click　event
		//	Parameter: 	strURL	:String	--- Move to URL after click
		//--------------------------------------------------------------------------
		private function closeDialogClick(objDialog:Object):Function{
			return function(event:Event):void{
				if(objDialog!=null)
				{
					objDialog.visible = false;
					var tmpParent = objDialog.parent;
					tmpParent.removeChild(objDialog);
					objDialog = null;
				}
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:showDialog
		//  Expranation: Get Sound Dialog
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------
		private function showDialog(strTargetName:String):void 
		{
			var strName:String = "";
			var objDialog:Object;
			const DIALOG:String = "Dialog"; 
   			for(var i:int=0; i<sprParent.numChildren; i++)
			{
				strName = sprParent.getChildAt(i).name;
				if(strName.indexOf(DIALOG,0)!=-1)
				{
					sprParent.getChildAt(i).visible = false;
				}				
				if(sprParent.getChildAt(i).name==strTargetName)
				{
					objDialog = sprParent.getChildAt(i);
					objDialog.x = sprParent.width/2 - objDialog.width/2;
					objDialog.y = Static_Value.INSTRACTOR_BASE_Y;
					sprParent.setChildIndex(MovieClip(objDialog),sprParent.numChildren-1);	//move front					
					objDialog.visible = true;
					break;
				}
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseClick
		//  Expranation: mouse Click　event
		//	Parameter: 	strURL	:String	--- Move to URL after click
		//--------------------------------------------------------------------------
		private function mouseClick(strURL:String,objDialog:Object):Function{
			return function(event:Event):void{
				if(strURL!="")
				{
					var objRequest:URLRequest = new URLRequest(strURL);
					var objLoader:Loader = new Loader();
					objLoader.load(objRequest);
					while(sprBase.numChildren > 0){
							//trace(sprBase.getChildAt(0).name);
							sprBase.removeChildAt(0);  
					}
					sprBase.addChild(objLoader);
				}else if(objDialog!=null)
				{
					showDialog(objDialog.name);
				}
			}
		}

		//--------------------------------------------------------------------------
		//  Method:onPlayComplete
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------	
		public function showMessage_Result(event:Event):void 
		{
			sndChannel.removeEventListener(Event.SOUND_COMPLETE,onPlayComplete);
			sndChannel.stop();
			numSndPosition = 0;
			isPlaying = false;
		}
		
		//--------------------------------------------------------------------------
		//  Method:updateSpeakerAlpha
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------	
		private function updateSpeakerAlpha(event:Event):void 
		{
			sndChannel.removeEventListener(Event.SOUND_COMPLETE,onPlayComplete);
			sndChannel.stop();
			numSndPosition = 0;
			isPlaying = false;
			image_FadeIn();
		}
	//フェードイン
		private function image_FadeIn():void
		{
			if(btnSpeaker.alpha<1){
				btnSpeaker.alpha += 0.01;
			}else{
				image_FadeOut();
			}
		}
		
		//フェードアウト
		private function image_FadeOut():void
		{
			if(btnSpeaker.alpha>0){
				btnSpeaker.alpha -= 0.01;
			}else{
				image_FadeIn();
			}
		}
		
		private function OnEnterFrame(e:Event):void
		{
			//curr_roop();
		}		

		
		//--------------------------------------------------------------------------
		//  Method:stopSound
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------	
		public function stopSound():void 
		{
			if(sndChannel!=null)
			{
				sndChannel.removeEventListener(Event.SOUND_COMPLETE,onPlayComplete);
				sndChannel.stop();
			}
			numSndPosition = 0;
			isPlaying = false;
		}
		
		//--------------------------------------------------------------------------
		//  Method:opened
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------
		public function get opened():Boolean
		{
			return m_opened;
		}
		
		private function onAddedToStage(objStage:Object=null,objShow:Object=null):Function{
			return function(event:Event):void{
				objShow.x = objStage.stageWidth / 2;
				objShow.y = objStage.stageHeight / 2;
				m_opened = true;
			}
		}
		
		private function onRemovedFromStage(event:Event):void
		{
			m_opened = false;
		}
		
		public function onClickBtnOk(event:MouseEvent):void
		{
			//dispatchEvent(new Event("CloseDialog"));
			event.stopPropagation();
		}
		
	}
}






