﻿package classes.common 
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.Loader;
	import flash.display.SimpleButton;
	import flash.display.Bitmap;	
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.geom.Rectangle;
	import flash.text.TextField;
	import flash.text.TextFormat; 
	import flash.events.TimerEvent;
	import flash.media.*;
	//import flash.filesystem.File;
	import classes.common.BaseStage;
	//import classes.common.Menubar_Menu;
	
	public class CreateMenuBar 
	{
		static private const BASE_BACKCOLOR_BASE:int = 0xEAE9ED;	//Base Background Color
		static private const MENUBAR_BACKCOLOR:int = 0x425F9C;		//Menubar Background Color
		static private const TEXT_COLOR_BASE:int = 0x425F9C; //0xFFFFFF;		//Basic Text Color
		static private const TEXT_FONT_TYPE:String = "Tahoma";
		static private const IMAGE_ARROW_LEFT:String = "image/Icons/arrow_left.png";
		static private const IMAGE_MENU:String = "image/Icons/menu.png";
		static private const MENUBAR_TXT:String = "txt_Title";		
		static private const BUTTON_NAME_BACK:String = "btn_Back";
		static private const BUTTON_NAME_MENU:String = "btn_Menu";
		
		private var m_objBase:BaseStage;
		private var m_sprBase:Sprite;
		private var m_sprParent:Sprite;
		private var m_sprMenuDisplay:Sprite;
		private var m_strRtnURL:String;
		private var m_strRtnCls:String;
		private var m_objRtnCls:Object;
		private var m_btnReturn:BaseButton;
		private var m_btnMenu:BaseButton;
		
		//--------------------------------------------------------------------------
		//  Method:CreateMenuBar
		//  Expranation: Constructor
		//	Parameter: 	val_sprBase			:Sprite	--- Sprite of Base
		//				val_sprParent		:Sprite	--- Sprite to add the menubar 
		//--------------------------------------------------------------------------	
		public function CreateMenuBar(val_objBase:BaseStage)
		{
			this.objBase = val_objBase;
			this.sprBase = val_objBase.sprMain;
			this.sprParent = val_objBase.sprMenubar;
			sprParent.x = 0;
			sprParent.y = 0;
		}
		
		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get objBase():BaseStage
		{
			return m_objBase;
		}
		public function set objBase(val:BaseStage):void
		{
			m_objBase = val;
		}		
		
		public function get sprBase():Sprite
		{
			return m_sprBase;
		}
		public function set sprBase(val:Sprite):void
		{
			m_sprBase = val;
		}
		
		public function get sprParent():Sprite
		{
			return m_sprParent;
		}
		public function set sprParent(val:Sprite):void
		{
			m_sprParent = val;
		}
		
		public function get sprMenuDisplay():Sprite
		{
			return m_sprMenuDisplay;
		}
		public function set sprMenuDisplay(val:Sprite):void
		{
			m_sprMenuDisplay = val;
		}
		
		public function get strRtnURL():String
		{
			return m_strRtnURL;
		}
		public function set strRtnURL(val:String):void
		{
			m_strRtnURL = val;
		}

		public function get strRtnCls():String
		{
			return m_strRtnCls;
		}
		public function set strRtnCls(val:String):void
		{
			m_strRtnCls = val;
		}

		public function get objRtnCls():Object
		{
			return m_objRtnCls;
		}
		public function set objRtnCls(val:Object):void
		{
			m_objRtnCls = val;
		}
		
		public function get btnReturn():BaseButton
		{
			return m_btnReturn;
		}
		public function set btnReturn(val:BaseButton):void
		{
			m_btnReturn = val;
		}		

		public function get btnMenu():BaseButton
		{
			return m_btnMenu;
		}
		public function set btnMenu(val:BaseButton):void
		{
			m_btnMenu = val;
		}
		
		//--------------------------------------------------------------------------
		//  Method:setMenubar
		//  Expranation: Setting for Common Menubar
		//	Parameter: 	txtTitle		:String	--- Display text
		//				numFontSize		:Number	--- Font Size 
		//				strReturnURL	:String	--- After Button_Back click, load the URL
		//				strReturnCls	:String	--- After Button_Back click, return object name 
		//				objReturnCls	:Object	--- After Button_Back click, return object 		
		//--------------------------------------------------------------------------	
		public function setMenubar(txtTitle:String,numFontSize:Number,strReturnURL:String
								   ,blnReturnURL:Boolean,strReturnCls:String="",objReturnCls:Object=null):void
		{
			/**Draw rectangle**/
			//createSquare();			
			/** Tittle**/
			setTextField(txtTitle,TEXT_FONT_TYPE,numFontSize,TEXT_COLOR_BASE,true,80,18,390);			
			/** Button Object - Back Button **/
			strRtnURL = strReturnURL;
			strRtnCls = strReturnCls;
			objRtnCls = objReturnCls;
			if(blnReturnURL){btnReturn = setButtonImage(IMAGE_ARROW_LEFT,BUTTON_NAME_BACK,5
														,8,1.0,clickReturnHandler);}
			/** Menu OOO **/
			btnMenu = setButtonImage(IMAGE_MENU,BUTTON_NAME_MENU,Static_Value.INFO_BUTTON_BASE_X
									 ,Static_Value.INFO_BUTTON_BASE_Y,1.0,clickMenuShowHandler);
			//-- Set for Menu items --//
			sprMenuDisplay = new Sprite();
			/**Draw rectangle**/
			sprMenuDisplay.graphics.lineStyle(1,Static_Value.BASE_BACKCOLOR_BASE);
			sprMenuDisplay.graphics.beginFill(Static_Value.BASE_BACKCOLOR_BASE);
			sprMenuDisplay.graphics.drawRect(20,0,750,479);
			sprMenuDisplay.graphics.endFill();
			sprMenuDisplay.x = 0;
			sprMenuDisplay.y = 0;
			sprMenuDisplay.name = "Menubar_Menu";
			sprMenuDisplay.visible = false;
			sprBase.addChild(sprMenuDisplay);
			var objMenubar_Menu:Menubar_Menu = new Menubar_Menu(sprBase,sprMenuDisplay);
			objMenubar_Menu.setMenu();
		}

		//--------------------------------------------------------------------------
		//  Method:replaceMenubar
		//  Expranation: Setting for Common Menubar
		//	Parameter: 	txtTitle		:String	--- Display text
		//				numFontSize		:Number	--- Font Size 
		//				strReturnURL	:String	--- After Button_Back click, load the URL
		//				strReturnCls	:String	--- After Button_Back click, return object name 
		//				objReturnCls	:Object	--- After Button_Back click, return object 		
		//--------------------------------------------------------------------------	
		public function replaceMenubar(txtTitle:String,numFontSize:Number,strReturnURL:String
								   		,strReturnCls:String,objReturnCls:Object):void
		{
			/** Cahnge Tittle**/
			for(var i:int=0; i<sprParent.numChildren; i++)
			{
				if(sprParent.getChildAt(i).name==MENUBAR_TXT)
				{
					var obj = sprParent.getChildAt(i);
					obj.text = txtTitle;
					/** Tittle**/
					var textFormat:TextFormat = new TextFormat ();
					textFormat.font = TEXT_FONT_TYPE;
					textFormat.size = numFontSize;			
					textFormat.color = TEXT_COLOR_BASE;
					textFormat.bold = true;
					obj.setTextFormat(textFormat);
					break;
				}
			}
			/** Cahnge click event **/
			//removeBtnBkEvent();
			strRtnURL = strReturnURL;
			strRtnCls = strReturnCls;
			objRtnCls = objReturnCls;
		}
		
		//--------------------------------------------------------------------------
		//  Method:createSquare
		//  Expranation: Draw the sqare of menubar
		//	Parameter: 	--- 
		//--------------------------------------------------------------------------	
		private function createSquare():void 
		{
			/**Draw rectangle**/
			var square:Sprite = new Sprite();
			this.sprParent.addChild(square);
			square.graphics.lineStyle(1,MENUBAR_BACKCOLOR);
			square.graphics.beginFill(MENUBAR_BACKCOLOR);
			square.graphics.drawRect(0,0,799,60);
			square.graphics.endFill();
		}
		
		//--------------------------------------------------------------------------
		//  Method:setTextField
		//  Expranation: Setting for TextField of Menubar
		//	Parameter: 	strTitle		:String	--- Display text
		//				strFontTyp		:String	--- Font Type
		//				numFontSize		:Number	--- Font Size
		//				intFontColor	:int	--- Font Color
		//				blnBold			:Boolean--- Font Bold
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numWidth		:Number	--- TextField Width
		//--------------------------------------------------------------------------	
		private function setTextField(strTitle:String,strFontTyp:String,numFontSize:Number
										,intFontColor:int,blnBold:Boolean,pos_X:Number
										,pos_Y:Number,numWidth:Number):void 
		{
			/** Tittle**/
			var menuBarTitle:TextField = new TextField ();
			menuBarTitle.name = MENUBAR_TXT;
			var textFormat:TextFormat = new TextFormat ();
			textFormat.font = strFontTyp;
			textFormat.size = numFontSize;			
			textFormat.color = intFontColor;
			textFormat.bold = blnBold;
			menuBarTitle.text = strTitle;
			menuBarTitle.setTextFormat(textFormat);
			menuBarTitle.x = pos_X;
			menuBarTitle.y = pos_Y;
			menuBarTitle.width = numWidth;
			sprParent.addChild(menuBarTitle);
		}

		//--------------------------------------------------------------------------
		//  Method:setButtonImage
		//  Expranation: Setting for Button of Menubar
		//	Parameter: 	strImgURL		:String	--- Display text
		//				strImgName		:String	--- Font Type
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale
		//--------------------------------------------------------------------------	
		private function setButtonImage(strImgURL:String,strImgName:String,pos_X:Number
										,pos_Y:Number,numScale:Number,func:Function):BaseButton 
		{
			var sprBtn:BaseButton = new BaseButton(strImgName);
			sprBtn.imageButton(strImgURL,numScale);
			sprBtn.x = pos_X;
			sprBtn.y = pos_Y;
			sprBtn.name = strImgName;
			sprBtn.removeEventListener(MouseEvent.CLICK,func);
			sprBtn.addEventListener(MouseEvent.CLICK,func);
			sprParent.addChild(sprBtn);
			return sprBtn;
		}

		//--------------------------------------------------------------------------
		//  Method:removeBtnBkEvent
		//  Expranation: Setting for Button of Menubar
		//	Parameter: 	--- 		
		//--------------------------------------------------------------------------	
		private function removeBtnBkEvent():void 
		{
			for(var i:int=0; i<sprParent.numChildren; i++)
			{
				if(sprParent.getChildAt(i).name==BUTTON_NAME_BACK)
				{
					var obj = sprParent.getChildAt(i);
					obj.removeEventListener(MouseEvent.CLICK,clickReturnHandler);
					break;
				}
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:clickReturnHandler
		//  Expranation: EventHandler to click the button
		//	Parameter: 	strReturnURL	:String	--- After Button_Back click, load the URL 		
		//--------------------------------------------------------------------------		
		public function clickReturnHandler(event:Event):void
		{
			// Stop the all sounds //
			SoundMixer.stopAll();
			// Hide the Menu //
			sprMenuDisplay.visible = false;
			// Main process //			
			if(strRtnURL!="")
			{
				var objURL:URLRequest = new URLRequest(strRtnURL)
				var objLoader:Loader = new Loader();
				objLoader.load(objURL);
				while(sprBase.numChildren > 0){
						sprBase.removeChildAt(0);  
				}
				sprBase.addChild(objLoader);
			}
			else if(strRtnCls!="")
			{
				//--- Delete Exercise ---//
				ClsLoader();
			}					
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseLoaderClick
		//  Expranation: mouseClickBeginEventHandler　event
		//	Parameter: 	strLoadURL		:String	--- class object name		
		//				strRtnCls		:String	--- class object name
		//				objRtnCls		:Object	--- Move to new class object after click		
		//--------------------------------------------------------------------------
		private function ClsLoader():void
		{
			if(strRtnCls!="" && objRtnCls!=null)
			{
				//-- Create New class object --//
				var objRequest = new objRtnCls;
				objRequest.name = strRtnCls;
				//-- Delete Slider --//
				for(var i:int=0; i<objBase.sprMain.numChildren; i++)
				{
					var objSld = objBase.sprMain.getChildAt(i);
					if(objSld.name==Static_Value.SPRITE_SLIDER)
					{
						/** Delete Slider Object **/
						while(objSld.numChildren > 0)
						{
							var obj = objSld.getChildAt(0);
							objSld.removeChild(obj);
							obj = null;
						}
						objBase.sprMain.removeChild(objSld);
						break;
					}
				}
				//--- Delete Previous next puttons ---//
//				objBase.sprPreNextBtn.parent.removeChild(objBase.sprPreNextBtn);
//				objBase.sprPreNextBtn = null;
				//--- Hide Footer Activity ---//
				objBase.sprFooter.visible = false;
				//--- Delete Exercise ---//
				while(objBase.sprExercise.numChildren > 0)
				{
					var objEx = objBase.sprExercise.getChildAt(0);
					objBase.sprExercise.removeChild(objEx);
					objEx = null;
				}
				objBase.sprExercise.addChild(objRequest);
				//-- Initialize of new class object --//
				objRequest.objBase = objBase;					
				objRequest.init();				
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:clickMenuShowHandler
		//  Expranation: EventHandler to click the button
		//	Parameter: 	strReturnURL	:String	--- After Button_Back click, load the URL 		
		//--------------------------------------------------------------------------		
		private function clickMenuShowHandler(event:Event):void
		{
			sprBase.setChildIndex(sprMenuDisplay,sprBase.numChildren-1);	//move front	
			sprMenuDisplay.visible = true;
		}		
	}
}