﻿package classes.common
{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.utils.Dictionary;
	import flash.media.*;
	import classes.common.BaseButton;
	import classes.common.CreateInstructor;
	import classes.common.Static_Value;
	
	public class Exercise
	{
		static private const COMMON_NAME:String = "Exercise_";
		static private const STAGE_WIDTH:Number = 480;
		static private const CHECK_BUTTON_IMAGE:String = "image/common/button_check.png";
		static private const CHECK_BUTTON_IMAGE_SMALL:String = "image/common/button_check_small.png";
		static private const CHECK_BUTTON_NAME:String = "Check";
		static private const PREVIOUS_BUTTON_IMAGE:String = "image/Icons/page_arrow_left.png";
		static private const PREVIOUS_BUTTON_NAME:String = "Previous";
		//static private const PREVIOUS_BUTTON_BASE_X:Number = 40;
		//static private const PREVIOUS_BUTTON_BASE_Y:Number = 0;//670;
		static private const NEXT_BUTTON_IMAGE:String = "image/Icons/page_arrow_right.png";
		static private const NEXT_BUTTON_NAME:String = "Next";
		//static private const NEXT_BUTTON_BASE_Y:Number = 0;//670;
		static private const MESSAGE_BASE_Y:Number = 200;
		static private const CORRECT:Boolean = true;
		static private const INCORRECT:Boolean = false;
		static private const SOUND_ON:Boolean = true;
		static private const SOUND_OFF:Boolean = false;	
		
		//var m_Exercises:Exercises;
		private var m_sprBase:Sprite;
		private var m_sprParent:Sprite;
		private var m_sprPreNext:Sprite;		
		private var m_objInstructor:CreateInstructor;
		private var m_dictQuestions = new Dictionary ();
		private var m_aryAnswers = new Array ();
		private var m_intCntQuestion:int = 0;
		private var m_intCntCorrect:int = 0;
		private var m_intTotalPages:int = 1;
		private var m_intCurrentPage:int = 0;
		private var m_strExcerciseType:String = "";
		private var m_flgConfirm:Boolean = false;
		private var m_flgFinish:Boolean = false;
		private var m_objCorrect:Object;
		private var m_objIncorrect:Object;
		private var m_objError:Object
		private var m_btnPrevious:BaseButton
		private var m_btnNext:BaseButton
		private var m_btnCheck:BaseButton;
		private var m_objPrevious:Object
		private var m_objCurrent:Object
		private var m_objNext:Object
		private var m_numObjOriginal_X:Number;
		private var m_numObjOriginal_Y:Number;
		private var m_obj:Object;
		private var m_objAnsScript:Object;
		private var m_btnAnswer:BaseButton;
		private var m_btnClose:BaseButton;
		
		//--------------------------------------------------------------------------
		//  Method:Exercise
		//  Expranation: Constructor
		//	Parameter: 	val_sprBase			:Sprite	--- Sprite of Base
		//				val_sprParent		:Sprite	--- Sprite to add the menubar 
		//--------------------------------------------------------------------------	
		public function Exercise(val_sprBase:Sprite,val_sprParent:Sprite)
		{
			this.sprBase = val_sprBase;
			this.sprParent = val_sprParent;
			//sprParent.x = 0;
			//sprParent.y = 0;
			objInstructor = new CreateInstructor(val_sprBase,val_sprParent);
		}
		
		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get sprBase():Sprite
		{
			return m_sprBase;
		}
		public function set sprBase(val:Sprite):void
		{
			m_sprBase = val;
		}
		
		public function get sprParent():Sprite
		{
			return m_sprParent;
		}
		public function set sprParent(val:Sprite):void
		{
			m_sprParent = val;
		}
		
		public function get sprPreNext():Sprite
		{
			return m_sprPreNext;
		}
		public function set sprPreNext(val:Sprite):void
		{
			m_sprPreNext = val;
		}
		
		public function get objInstructor():CreateInstructor
		{
			return m_objInstructor;
		}
		public function set objInstructor(val:CreateInstructor):void
		{
			m_objInstructor = val;
		}
		
		public function get intCntQuestion():int
		{
			return m_intCntQuestion;
		}		
		public function set intCntQuestion(val:int):void
		{
			m_intCntQuestion = val;
		}

		public function get intCntCorrect():int
		{
			return m_intCntCorrect;
		}		
		public function set intCntCorrect(val:int):void
		{
			m_intCntCorrect = val;
		}

		public function get intTotalPages():int
		{
			return m_intTotalPages;
		}		
		public function set intTotalPages(val:int):void
		{
			m_intTotalPages = val;
		}

		public function get intCurrentPage():int
		{
			return m_intCurrentPage;
		}		
		public function set intCurrentPage(val:int):void
		{
			m_intCurrentPage = val;
		}
		
		public function get strExcerciseType():String
		{
			return m_strExcerciseType;
		}		
		public function set strExcerciseType(val:String):void
		{
			m_strExcerciseType = val;
		}

		public function get dictQuestions():Dictionary
		{
			return m_dictQuestions;
		}		
		public function set dictQuestions(val:Dictionary):void
		{
			m_dictQuestions = val;
		}

		public function get aryAnswers():Array
		{
			return m_aryAnswers;
		}		
		public function set aryAnswers(val:Array):void
		{
			m_aryAnswers = val;
		}
		
		public function get flgConfirm():Boolean
		{
			return m_flgConfirm;
		}
		public function set flgConfirm(val:Boolean):void
		{
			m_flgConfirm = val;
		}

		public function get flgFinish():Boolean
		{
			return m_flgFinish;
		}
		public function set flgFinish(val:Boolean):void
		{
			m_flgFinish = val;
		}
		
		public function get objCorrect():Object
		{
			return m_objCorrect;
		}
		public function set objCorrect(val:Object):void
		{
			m_objCorrect = val;
		}

		public function get objIncorrect():Object
		{
			return m_objIncorrect;
		}
		public function set objIncorrect(val:Object):void
		{
			m_objIncorrect = val;
		}
		
		public function get objError():Object
		{
			return m_objError;
		}
		public function set objError(val:Object):void
		{
			m_objError = val;
		}

		public function get btnPrevious():BaseButton
		{
			return m_btnPrevious;
		}
		public function set btnPrevious(val:BaseButton):void
		{
			m_btnPrevious = val;
		}
		
		public function get btnNext():BaseButton
		{
			return m_btnNext;
		}
		public function set btnNext(val:BaseButton):void
		{
			m_btnNext = val;
		}

		public function get btnCheck():BaseButton
		{
			return m_btnCheck;
		}
		public function set btnCheck(val:BaseButton):void
		{
			m_btnCheck = val;
		}
		
		public function get objPrevious():Object
		{
			return m_objPrevious;
		}
		public function set objPrevious(val:Object):void
		{
			m_objPrevious = val;
		}
		
		public function get objCurrent():Object
		{
			return m_objCurrent;
		}
		public function set objCurrent(val:Object):void
		{
			m_objCurrent = val;
		}
			
		public function get objNext():Object
		{
			return m_objNext;
		}
		public function set objNext(val:Object):void
		{
			m_objNext = val;
		}
		
		public function get numObjOriginal_X():Number
		{
			return m_numObjOriginal_X;
		}
		public function set numObjOriginal_X(val:Number):void
		{
			m_numObjOriginal_X = val;
		}
		
		public function get numObjOriginal_Y():Number
		{
			return m_numObjOriginal_Y;
		}
		public function set numObjOriginal_Y(val:Number):void
		{
			m_numObjOriginal_Y = val;
		}		

		public function get btnAnswer():BaseButton
		{
			return m_btnAnswer;
		}
		public function set btnAnswer(val:BaseButton):void
		{
			m_btnAnswer = val;
		}

		//--------------------------------------------------------------------------
		//  methods:setExerciseInfo
		//  Expranation: To set  each excercise
		//	Parameter: 	intPages		:int	--- Total page
		//				strExcerciseType:String	--- Excercise Type
		//				sprBaseExercise:Sprite	--- Sprite for previouse and next button		
		//--------------------------------------------------------------------------		
		public function setExerciseInfo(intPages:int,strExcerciseType:String)//,sprBaseExercise:Sprite)
		{
			this.intTotalPages = intPages;
			this.intCurrentPage = 1;
			this.strExcerciseType = strExcerciseType;
			//this.sprBaseExercise = sprBaseExercise;
		}
		
		//--------------------------------------------------------------------------
		//  methods:setScreen
		//  Expranation: To set display page
		//	Parameter: 	objPrevious		:Object	--- Previous page
		//				objCurrent		:Object	--- Current page
		//				objNext			:Object	--- Next page
		//--------------------------------------------------------------------------	
		public function setScreen(objPrevious:Object=null,objCurrent:Object=null,objNext:Object=null)
		{
			if (objCurrent!=null){this.objCurrent = objCurrent;}
			if (intTotalPages>1)
			{
				if (objPrevious!=null){this.objPrevious = objPrevious;}
				if (objNext!=null) {this.objNext = objNext;}
			}
		}

		//--------------------------------------------------------------------------
		//  Method:setAnswer
		//  Expranation: Set Answer Script
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------
		public function setAnswer(objAns:Object,numChkBtnPos_X:Number,numChkBtnPos_Y:Number):void 
		{
			m_objAnsScript = new objAns;
			m_objAnsScript.name = "Answer_Script";
			sprParent.addChild(MovieClip(m_objAnsScript));
			m_objAnsScript.x = sprParent.width/2 - m_objAnsScript.width/2;
			m_objAnsScript.y = 0; 
			m_objAnsScript.visible = false;
			
			btnAnswer = new BaseButton("Answer");
			btnAnswer.textButton("Answer",120,40,true,26,Static_Value.FONT_TYPE_BASE,10);
			btnAnswer.x = numChkBtnPos_X;
			btnAnswer.y = numChkBtnPos_Y;
			btnAnswer.name = "Btn_Answer";
			sprParent.addChild(btnAnswer);
			btnAnswer.visible = false;
			btnAnswer.removeEventListener(MouseEvent.CLICK,showAnswerScript);
			btnAnswer.addEventListener(MouseEvent.CLICK,showAnswerScript);
			//Button Close
			var tmp_W:Number = m_objAnsScript.width;
			var tmp_H:Number = m_objAnsScript.height;
			m_btnClose = new BaseButton("Close");
			m_btnClose.textButton("Close",60,25,true,18,Static_Value.FONT_TYPE_BASE,10);
			m_btnClose.x = tmp_W - 100;
			m_btnClose.y = tmp_H - 30;
			m_btnClose.name = "Btn_close";
			m_objAnsScript.addChild(m_btnClose);
		}		

		//--------------------------------------------------------------------------
		//  Method:showAnswer
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------	
		private function showAnswerScript(event:MouseEvent):void 
		{
   			if(m_objAnsScript!=null)
			{
				m_objAnsScript.visible = true;
				m_btnClose.addEventListener(MouseEvent.CLICK,mouseCloseClick);
				sprParent.setChildIndex(MovieClip(m_objAnsScript),sprParent.numChildren-1);	//move front
			}
		}

		//--------------------------------------------------------------------------
		//  Method:mouseCloseClick
		//  Expranation: EventHandler to click the button
		//	Parameter: 	strReturnURL	:String	--- After Button_Back click, load the URL 		
		//--------------------------------------------------------------------------		
		private function mouseCloseClick(event:Event):void
		{
			m_objAnsScript.visible = false;
			m_btnClose.removeEventListener(MouseEvent.CLICK,mouseCloseClick);
		}

		//--------------------------------------------------------------------------
		//  methods:changePage
		//  Expranation: This is a function to change page.
		//	Parameter: 	event:				MouseEvent 	--- Mouse_CLICK event
		//  Return: void
		//--------------------------------------------------------------------------		
		public function changePage ()
		{
			if (intCntCorrect==intCntQuestion)
			{
				if (intTotalPages>intCurrentPage)
				{
					if (btnPrevious!=null){btnPrevious.visible = false;}
					if (btnNext!=null){btnNext.visible = true;}						
				}
				else if (intTotalPages==intCurrentPage)
				{
					if (btnPrevious!=null){btnPrevious.visible = true;}
					if (btnNext!=null){btnNext.visible = false;}								
				}
				else if(intTotalPages>intCurrentPage && intCurrentPage>1)
				{
					if (btnPrevious!=null){btnPrevious.visible = true;}
					if (btnNext!=null){btnNext.visible = true;}							
				}
				flgFinish = true;
				intCurrentPage = intCurrentPage + 1;
			}
		}

		//--------------------------------------------------------------------------
		//  Method:create_prev_next
		//  Expranation: Create previous and next button area
		//	Parameter: 	intPages		:int	--- Total page
		//				strExcerciseType:String	--- Excercise Type
		//				pos_X		:Number	--- previous and next button area position X 
		//				pos_Y		:Number	--- previous and next button area position Y		
		//--------------------------------------------------------------------------
		public function create_prev_next(objParent:Sprite=null,pos_X:Number=0,pos_Y:Number=Static_Value.PREV_NXT_BUTTON_BASE_Y)
		{	
			///**Instructor**///
			if(objParent!=null){sprPreNext = objParent;}
			else{sprPreNext = new Sprite();}
			sprPreNext.x = pos_X;
			sprPreNext.y = pos_Y;
			//trace("sprPreNext.y:" + sprPreNext.y);
			sprPreNext.name = "sprPreNext";
			//sprBase.addChild(sprPreNext);
			sprParent.addChild(sprPreNext);
			setNextPrvButton(Static_Value.PREV_BUTTON_BASE_X,Static_Value.PREV_NXT_BUTTON_BASE_Y,Static_Value.NXT_BUTTON_BASE_X,Static_Value.PREV_NXT_BUTTON_BASE_Y);				
		}
		
		//--------------------------------------------------------------------------
		//  Method:setNextPrvButton
		//  Expranation: Setting for Next and Previous Button
		//	Parameter: 		---		
		//--------------------------------------------------------------------------	
		public function setNextPrvButton(pre_pos_X:Number=Static_Value.PREV_BUTTON_BASE_X,pre_pos_Y:Number=Static_Value.PREV_NXT_BUTTON_BASE_Y
										 ,nxt_pos_X:Number=Static_Value.NXT_BUTTON_BASE_X,nxt_pos_Y:Number=Static_Value.PREV_NXT_BUTTON_BASE_Y)
		{
			setPreviousButton(pre_pos_X,pre_pos_Y);
			setNextButton(nxt_pos_X,nxt_pos_Y);
		}

		//--------------------------------------------------------------------------
		//  Method:setPreviousButton
		//  Expranation: Setting for Previous Button
		//	Parameter: 		---		
		//--------------------------------------------------------------------------	
		private function setPreviousButton(pos_X:Number,pos_Y:Number):void 
		{
			btnPrevious = new BaseButton(PREVIOUS_BUTTON_NAME);
			btnPrevious.imageButton(PREVIOUS_BUTTON_IMAGE,1.0);
			btnPrevious.x = pos_X;
			btnPrevious.y = pos_Y;
			btnPrevious.name = "Btn_Previous";
			btnPrevious.addEventListener(MouseEvent.CLICK,clickPreviousHandler);
			//sprParent.addChild(btnPrevious);
			sprPreNext.addChild(btnPrevious);
			btnPrevious.visible = false;
//			trace("btnPrevious.x:" + btnPrevious.x);
//			trace("btnPrevious.y:" + btnPrevious.y);
		}

		//--------------------------------------------------------------------------
		//  Method:setNextButton
		//  Expranation: Setting for Next Button
		//	Parameter: 		---		
		//--------------------------------------------------------------------------	
		private function setNextButton(pos_X:Number,pos_Y:Number):void 
		{
			btnNext = new BaseButton(NEXT_BUTTON_NAME);
			btnNext.imageButton(NEXT_BUTTON_IMAGE,1.0);
			btnNext.x = pos_X;
			btnNext.y = pos_Y;
			btnNext.name = "Btn_Next";
			btnNext.addEventListener(MouseEvent.CLICK,clickNextHandler);
			//sprParent.addChild(btnNext);
			sprPreNext.addChild(btnNext);
		}

		//--------------------------------------------------------------------------
		//  Method:createCheckButton
		//  Expranation: Setting for Check Button
		//	Parameter: 	pos_X		:Number	--- Check Button position x
		//				pos_Y		:Number	--- Check Button position y
		//				strFunction	:Function	--- function after click
		//				blnLarge	:Boolean	--- buttonSize
		//--------------------------------------------------------------------------	
		public function createCheckButton(pos_X:Number,pos_Y:Number,numScale:Number
									   		,strFunction:Function,blnLarge:Boolean=true):BaseButton 
		{
			var tmpBtnCheck = new BaseButton(CHECK_BUTTON_NAME);
			if(blnLarge){tmpBtnCheck.imageButton(CHECK_BUTTON_IMAGE,numScale);}
			else{tmpBtnCheck.imageButton(CHECK_BUTTON_IMAGE_SMALL,numScale);}
			tmpBtnCheck.x = pos_X;
			tmpBtnCheck.y = pos_Y;
			tmpBtnCheck.name = "Btn_Check";
			if(strFunction!=null){tmpBtnCheck.addEventListener(MouseEvent.CLICK,strFunction);}
			//sprParent.addChild(btnCheck);
			return tmpBtnCheck
		}

//		//--------------------------------------------------------------------------
//		//  Method:createComboBox
//		//  Expranation: Setting for Check Button
//		//	Parameter: 	pos_X		:Number	--- Check Button position x
//		//				pos_Y		:Number	--- Check Button position y
//		//				strFunction	:Function	--- function after click
//		//--------------------------------------------------------------------------	
//		public function createComboBox(aryData:Array,pos_X:Number,pos_Y:Number
//									   ,combo_Width:Number,combo_Height:Number):CreateComboBox 
//		{
//			var objCombo = new CreateComboBox();
//			objCombo.setComboBox("",aryData,pos_X,pos_Y,combo_Width,combo_Height);
//			return objCombo
//		}
		
		//--------------------------------------------------------------------------
		//  methods:clickNextHandler
		//  Expranation: This is a eventHandler for Clicking Next Button.
		//	Parameter: 	event:				MouseEvent 	--- Mouse_CLICK event
		//  Return: void
		//--------------------------------------------------------------------------
		private function clickNextHandler (event:MouseEvent)
		{
			var i:int=0;
			var strName:String = "";
			if(objPrevious!=null){objPrevious.visible = false;}
			if(objCurrent!=null){objCurrent.visible = false;}
			if(objNext!=null)
			{
				for(i=0; i<objNext.numChildren; i++)
				{
					strName = objNext.getChildAt(i).name;
					if(strName=="Select")
					{
						objNext.getChildAt(i).visible = false;
						break;
					}
				}
				objNext.visible = true;			
			}
			var strSearch:String = COMMON_NAME;
			var intPos:int = 0;
			var intPage:int = 0;
			if(objCurrent.name.indexOf(strSearch,intPos)!=-1)
			{
				intCurrentPage = objCurrent.name.substr(strSearch.length,objCurrent.name.length - strSearch.length);
				objPrevious = objCurrent;
				btnPrevious.visible = true;
				objCurrent = objNext;
				//-- Set Nextpage				
				intCurrentPage = intCurrentPage + 1;
				if(intCurrentPage<intTotalPages)
				{
					for(i=0; i<objCurrent.parent.numChildren; i++)
					{
						strName = objCurrent.parent.getChildAt(i).name;
						if(strName.indexOf(strSearch,intPos)!=-1)
						{
							intPage = int(strName.substr(strSearch.length,objCurrent.name.length - strSearch.length));
							if(intPage == intCurrentPage + 1)
							{
								objNext = objCurrent.parent.getChildAt(i);
								break;
							}
						}
					}
				}
				else
				{
					objNext = null;
					btnNext.visible = false;
				}
			}
			else
			{
				trace("Page No is not found.");
			}
			// Stop the all sounds //
			SoundMixer.stopAll();
		}
		
		//--------------------------------------------------------------------------
		//  methods:clickPreviousHandler
		//  Expranation: This is a eventHandler for Clicking Previous Button.
		//	Parameter: 	event:				MouseEvent 	--- Mouse_CLICK event
		//  Return: void
		//--------------------------------------------------------------------------		
		private function clickPreviousHandler (event:MouseEvent)
		{
			var i:int=0;
			var strName:String = "";			
			if(objPrevious!=null)
			{
				for(i=0; i<objPrevious.numChildren; i++)
				{
					strName = objPrevious.getChildAt(i).name;
					if(strName=="Select")
					{
						objPrevious.getChildAt(i).visible = false;
						break;
					}
				}
				objPrevious.visible = true;			
			}
			if(objCurrent!=null){objCurrent.visible = false;}
			if(objNext!=null){objNext.visible = false;}

			var strSearch:String = COMMON_NAME;
			var intPos:int = 0;
			var intPage:int = 0;
			if(objCurrent.name.indexOf(strSearch,intPos)!=-1)
			{
				intCurrentPage = objCurrent.name.substr(strSearch.length,objCurrent.name.length - strSearch.length);	
				objNext = objCurrent;
				btnNext.visible = true;
				objCurrent = objPrevious;
				//-- Set Previouspage
				intCurrentPage = intCurrentPage - 1;
				if(intCurrentPage>1)
				{
					for(i=0; i<objCurrent.parent.numChildren; i++)
					{
						strName = objCurrent.parent.getChildAt(i).name;
						if(strName.indexOf(strSearch,intPos)!=-1)
						{
							intPage = int(strName.substr(strSearch.length,objCurrent.name.length - strSearch.length));
							if(intPage == intCurrentPage - 1)
							{
								objPrevious = objCurrent.parent.getChildAt(i);
								break;
							}
						}
					}
				}
				else
				{
					objPrevious = null;
					btnPrevious.visible = false;
				}
			}
			else
			{
				trace("Page No is not found.");
			}
			// Stop the all sounds //
			SoundMixer.stopAll();			
		}
		
		//--------------------------------------------------------------------------
		//  Method:showMsg
		//  Expranation: Setting for correct message
		//	Parameter: 	blnCorrect		:Boolean	--- true:correct, false:incorrect
		//				blnSound		:Boolean	--- true:sound on, false:sound off
		//--------------------------------------------------------------------------	
		public function showMsg(blnCorrect:Boolean,blnMsg:Boolean,blnSound:Boolean
								,blnSpell:Boolean=false):void 
		{
			if(blnCorrect)
			{
				if(objInstructor.btnCorrect.x==0)
				{
					objInstructor.btnCorrect.x = objInstructor.btnCorrect.parent.width/2 - objInstructor.btnCorrect.imgBtnWidth/2;
				}
				if(objInstructor.btnCorrect.y==0)
				{
					objInstructor.btnCorrect.y = objInstructor.btnCorrect.parent.height/2 - objInstructor.btnCorrect.imgBtnHeight/2;
				}
				if(blnMsg){objInstructor.btnCorrect.visible = true;}
				if(blnSound){objInstructor.playSound_Correct();}
			}
			else
			{
				if(!blnSpell)
				{
					if(objInstructor.btnIncorrect.x==0)
					{
						objInstructor.btnIncorrect.x = objInstructor.btnIncorrect.parent.width/2 - objInstructor.btnIncorrect.imgBtnWidth/2;
						//objInstructor.btnIncorrect.x = sprBase.width/2 - objInstructor.btnIncorrect.imgBtnWidth/2;
					}
					if(objInstructor.btnIncorrect.y==0)
					{
						objInstructor.btnIncorrect.y = objInstructor.btnIncorrect.parent.height/2 - objInstructor.btnIncorrect.imgBtnHeight/2;
					}		
					if(blnMsg){objInstructor.btnIncorrect.visible = true;}
				}else
				{
					if(objInstructor.btnIncorrectSpell.x==0)
					{
						objInstructor.btnIncorrectSpell.x = objInstructor.btnIncorrectSpell.parent.width/2 - objInstructor.btnIncorrectSpell.imgBtnWidth/2;
					}
					if(objInstructor.btnIncorrectSpell.y==0)
					{
						objInstructor.btnIncorrectSpell.y = objInstructor.btnIncorrectSpell.parent.height/2 - objInstructor.btnIncorrectSpell.imgBtnHeight/2;
					}		
					if(blnMsg){objInstructor.btnIncorrectSpell.visible = true;}
				}
				if(blnSound){objInstructor.playSound_Incorrect();}
			}
		}

		//--------------------------------------------------------------------------
		//  Method:showProfessor
		//  Expranation: Setting for correct message
		//	Parameter: 	blnCorrect		:Boolean	--- true:correct, false:incorrect
		//				blnSound		:Boolean	--- true:sound on, false:sound off
		//--------------------------------------------------------------------------	
		public function showProfessor(objVal:Object,pos_X:Number,pos_Y:Number):void 
		{
			var objCongratulations = new objVal;
			objCongratulations.x = pos_X;
			objCongratulations.y = pos_Y;
			sprParent.addChild(objCongratulations);
		}
		
		//--------------------------------------------------------------------------
		//  Method:clickCheckHandler
		//  Expranation: mouseClick　event
		//	Parameter: 	strURL	:String	--- Move to URL after click
		//--------------------------------------------------------------------------
		private function clickCheckHandler(strURL:String):Function{
			return function(event:Event):void{
/*				var objRequest:URLRequest = new URLRequest(strURL);
				var objLoader:Loader = new Loader();
				objLoader.load(objRequest);
				while(objBase.sprMain.numChildren > 0){
						trace(objBase.sprMain.getChildAt(0).name);
						objBase.sprMain.removeChildAt(0);  
				}
				objBase.sprMain.addChild(objLoader);
*/				
			}
		}	
		
	}
}