﻿package classes.common
{
	import flash.utils.Dictionary;
	import flash.display.Sprite;
	import flash.display.DisplayObject;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import classes.common.Static_Value;
	
	public class Exercise_DragAndDrop extends Exercise
	{
		//--------------------------------------------------------------------------
		//  Method:Exercise_DragAndDrop
		//  Expranation: Constructor
		//	Parameter: 	val_sprBase			:Sprite	--- Sprite of Base
		//				val_sprParent		:Sprite	--- Sprite to add the menubar 
		//--------------------------------------------------------------------------		
		public function Exercise_DragAndDrop(val_sprBase:Sprite,val_sprParent:Sprite) 
		{
			super(val_sprBase,val_sprParent);
		}

		//--------------------------------------------------------------------------
		//  methods:setExcercise  //override
		//  Expranation: To set  each excercise
		//	Parameter: 	strExcerciseType:	String 		--- Type of Excercise
		//				dict:				Dictionary 	--- Questions Data
		//--------------------------------------------------------------------------
		public function setExercise(intPages:int,strExcerciseType:String,dict:Dictionary = null
									,blnOff:Boolean = false):void
		{
			super.setExerciseInfo(intPages,strExcerciseType);
			if (dict != null)
			{
				super.dictQuestions = dict;
				super.intCntCorrect = 0;
				if(blnOff==false){setExerciseDragAndDrop(dict);}
				else{setExerciseDragAndDrop_off(dict);}
			}
			else
			{
				trace("DragAndDrop: Questions = 0...");
			}				
		}

		//--------------------------------------------------------------------------
		//  methods:setExerciseDragAndDrop
		//  Expranation: To set exercises DragAndDrop
		//	Parameter: 	dict:				Dictionary 	--- Questions Data
		//  Return: void
		//--------------------------------------------------------------------------
		private function setExerciseDragAndDrop(dict:Dictionary):void
		{
			var count:int = 0;
			for each (var item in dict)
			{
				item.addEventListener(MouseEvent.MOUSE_DOWN,pickupObjectHandler);
				item.addEventListener(MouseEvent.MOUSE_UP,dropObjectHandler);
				count = count + 1;
				item.buttonMode = true; //needed for the hand cursor
			}
			super.intCntQuestion = count;
		}		

		//--------------------------------------------------------------------------
		//  methods:setExerciseDragAndDrop
		//  Expranation: To set exercises DragAndDrop
		//	Parameter: 	dict:				Dictionary 	--- Questions Data
		//  Return: void
		//--------------------------------------------------------------------------
		private function setExerciseDragAndDrop_off(dict:Dictionary):void
		{
			var count:int = 0;
			for each (var item in dict)
			{
				item.addEventListener(MouseEvent.MOUSE_DOWN,pickupObjectHandler);
				item.addEventListener(MouseEvent.MOUSE_UP,dropObjectHandler_off);				
				count = count + 1;
				item.buttonMode = true; //needed for the hand cursor
			}
			super.intCntQuestion = count;
		}
		
		//--------------------------------------------------------------------------
		//  methods:pickupObjectHandler
		//  Expranation: This is a eventHandler for Mouse_DOWN(pick up a object).
		//	Parameter: 	event:				MouseEvent 	--- Mouse_DOWN event
		//  Return: void
		//--------------------------------------------------------------------------
		private function pickupObjectHandler(event:MouseEvent):void
		{
			var obj = event.target;
			super.objInstructor.stopSound();
			obj.startDrag();
			obj.useHandCursor = true;
			//obj.parent.addChild(obj);
			super.numObjOriginal_X = obj.x;
			super.numObjOriginal_Y = obj.y;
		}
		
		//--------------------------------------------------------------------------
		//  methods:dropObjectHandler
		//  Expranation: This is a eventHandler for Mouse_UP(drop a object).
		//	Parameter: 	event:				MouseEvent 	--- Mouse_UP event
		//  Return: void
		//--------------------------------------------------------------------------
		private function dropObjectHandler(event:MouseEvent):void
		{
			const CORRECT:Boolean = true;
			const INCORRECT:Boolean = false;
			const MSG_ON:Boolean = true;
			const MSG_OFF:Boolean = false;			
			const SOUND_ON:Boolean = true;
			const SOUND_OFF:Boolean = false;	
			
			event.target.stopDrag();
			var obj = event.target;
			var matchingTarget = event.target.dropTarget;
			var objDropTargetParent = matchingTarget.parent;
//			trace("obj.name:" + obj.name);
//			trace("obj.parent.name:" + obj.parent.name);
//			trace("objDropTargetParent.name:" + objDropTargetParent.name);
//			trace("matchingTarget.name:" + matchingTarget.name);
//			trace("objDropTargetParent.parent.name:" + objDropTargetParent.parent.name);
			if(objDropTargetParent != null && objDropTargetParent.name.indexOf("A_")!= -1)
			{
				obj.x = objDropTargetParent.x;
				obj.y = objDropTargetParent.y;
				super.flgConfirm = machingConfirm(super.dictQuestions,objDropTargetParent,obj);
				if(super.flgConfirm == true)
				{
					obj.buttonMode = false;
					if(super.intCntQuestion == super.intCntCorrect)
					{
						super.showProfessor(congratulations,Static_Value.PUZZLE_CONGRATU_BASE_POS_X,Static_Value.PUZZLE_CONGRATU_BASE_POS_Y);
					}
					//super.showMsg(CORRECT,MSG_ON,SOUND_ON);
				}
				else
				{
					//super.showMsg(INCORRECT,MSG_ON,SOUND_ON);
					obj.x = super.numObjOriginal_X;
					obj.y = super.numObjOriginal_Y;
				}
			}
			else
			{
				obj.x = super.numObjOriginal_X;
				obj.y = super.numObjOriginal_Y;
			}
		}

		//--------------------------------------------------------------------------
		//  methods:dropObjectHandler_off
		//  Expranation: This is a eventHandler for Mouse_UP(drop a object).
		//	Parameter: 	event:				MouseEvent 	--- Mouse_UP event
		//  Return: void
		//--------------------------------------------------------------------------
		private function dropObjectHandler_off(event:MouseEvent):void
		{			
			event.target.stopDrag();
		}
		
		//--------------------------------------------------------------------------
		//  methods:machingConfirm
		//  Expranation: To confirm the operations
		//	Parameter: 	dict:		Dictionary 	--- Questions Data
		//				target:		DisplayObject --- the target object which dropped the object into
		//				obj:		DisplayObject --- the object which holding
		//  Return:		Boolean
		//--------------------------------------------------------------------------
		private function machingConfirm(dict:Dictionary,target:DisplayObject,obj:DisplayObject):Boolean
		{
			// test if the pairs match
			if (dict[target] == obj)
			{
				// we got a hit
				super.intCntCorrect = super.intCntCorrect+1;
				// make the object transparent
				obj.alpha = 0.7;
				// kill its event listeners - object can't be moved anymore
				obj.removeEventListener(MouseEvent.MOUSE_DOWN,pickupObjectHandler);
				obj.removeEventListener(MouseEvent.MOUSE_UP,dropObjectHandler);
				//super.changePage();
				return true;
			}
			else
			{
				return false;
			}
		}
	}
}