﻿package classes.common
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.utils.Dictionary;	
	import classes.common.BaseStage;
	import classes.common.Static_Value;
	import classes.common.Item;
	import classes.common.Exercise;
	import classes.common.Exercise_DragAndDrop;
	
	public class Exercise_Emotion extends Exercise
	{		
		private var m_objBase:BaseStage;
		private var m_arySprItems:Array = new Array();
		private var m_aryExercise:Array = new Array();
		private var m_aryExercise_Ans:Array = new Array();
		private var m_aryExercise_Items:Array = new Array();
		private var m_intScore:int;
		private var m_strTestType:String;
		private var m_sprMenuDisplay:Sprite;

		//--------------------------------------------------------------------------
		//  Method:Exercise_Emotion
		//  Expranation: Constructor
		//	Parameter: 	val_sprBase			:Sprite	--- Sprite of Base
		//				val_sprParent		:Sprite	--- Sprite to add the menubar 
		//--------------------------------------------------------------------------	
		public function Exercise_Emotion(objBase:BaseStage)
		{
			m_objBase = objBase;
			super(objBase.sprMain,objBase.sprExercise);
		}

		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------

		//--------------------------------------------------------------------------
		//  methods:setExercise_DragAndDrop_Single
		//  Expranation: To set  each excercise
		//	Parameter: 	objPanel		:Object	--- Item's Movieclip
		//--------------------------------------------------------------------------
		public function setExercise_DragAndDrop(objPanel:Object,strResetImgURL:String,btnReset_pos_X:Number
												,btnReset_pos_Y:Number):void
		{
			//* Set items *//
			setContainerItems_DragAndDrop(objPanel,strResetImgURL,btnReset_pos_X,btnReset_pos_Y);
		}

		//--------------------------------------------------------------------------
		//  Method:setContainerItems_DragAndDrop_Single
		//  Expranation: Setting for the containers of the jobs
		//	Parameter: 	aryPanel		:Array	--- Item's Movieclip
		//				aryDic			:Array	--- Item's Answer
		//--------------------------------------------------------------------------
		private function setContainerItems_DragAndDrop(valPanel:Object,strResetImgURL:String,btnReset_pos_X:Number
													   ,btnReset_pos_Y:Number):void
		{
			/** Set Exercise **/
			// Basic setting //
			var intPage:int = 0;
			var objPanel = new valPanel;
			m_arySprItems[intPage] = new Sprite;
			m_arySprItems[intPage].addChild(objPanel);	
			super.sprParent.addChild(m_arySprItems[intPage]);
			m_arySprItems[intPage].name = "Exercise_" + (intPage + 1).toString();
			m_arySprItems[intPage].x = (super.sprBase.width - objPanel.width)/2; 
			m_arySprItems[intPage].y = 0;
			// Objects setting //
			m_aryExercise[intPage] = new Exercise_DragAndDrop(super.sprBase,objPanel);
			//m_aryExercise[intPage].objInstructor.setBasicInstructor_Response();
			m_aryExercise_Ans[intPage] = new Array();
			var dicVal = new Dictionary ();
			var objItem:Item;
			var intNum:int = 0;
			for(var intObj:int=0; intObj<objPanel.numChildren; intObj++)
			{
				var strName:String = objPanel.getChildAt(intObj).name;
				var objPart = objPanel.getChildAt(intObj);
				if(strName.indexOf("B_")!=-1)
				{
					dicVal[intObj] = objPanel.getChildAt(intObj);
					objItem = new Item(super.sprBase,objPanel);
					objItem.ItemName = strName;
					objItem.pos_X = objPart.x;
					objItem.pos_Y = objPart.y;
					m_aryExercise_Items[intNum] = new Array();
					m_aryExercise_Items[intNum] = objItem;
					intNum = intNum + 1;
				}
				super.intCntQuestion = super.intCntQuestion + 1;
				//trace("strName:" + strName);
			}
			m_aryExercise_Ans[intPage] = dicVal;
			m_aryExercise[intPage].setExercise(1,"DragAndDrop",dicVal,true);
			/* Set Reset buttons */
			setResetButton(objPanel,strResetImgURL,Static_Value.RESET_BUTTON_NAME
							,btnReset_pos_X,btnReset_pos_Y);
			///**Menu Bar**///
			m_objBase.create_menubar("",Static_Value.MENUBAR_TTL_L,"Emotion.swf",true);
		}

		//--------------------------------------------------------------------------
		//  Method:setResetButton
		//  Expranation: Setting for Reset Button
		//	Parameter: 		---		
		//--------------------------------------------------------------------------	
		private function setResetButton(valPanel:Object,strImg:String,strName:String
									   ,pos_X:Number,pos_Y:Number):void 
		{			
			var objBtn:BaseButton = new BaseButton(strName);
			objBtn.imageButton(strImg,1.0);
			objBtn.x = pos_X;
			objBtn.y = pos_Y;
			objBtn.name = "Btn_" + strName;
			objBtn.addEventListener(MouseEvent.CLICK,clickResetHandler(valPanel));
			valPanel.addChild(objBtn);
			objBtn.visible = true;
		}

		//--------------------------------------------------------------------------
		//  Method:clickResetHandler
		//  Expranation: mouseClick　event
		//	Parameter: 	objVal	:Object	--- Reset Panel
		//--------------------------------------------------------------------------
		private function clickResetHandler(objVal:Object):Function{
			return function(event:Event):void{
				for(var intObj:int=0; intObj<objVal.numChildren; intObj++)
				{
					var strName:String = objVal.getChildAt(intObj).name;
					var objPart = objVal.getChildAt(intObj);
					for(var intNum:int=0; intNum<m_aryExercise_Items.length; intNum++)
					{
						var objItem:Item = m_aryExercise_Items[intNum];
						if(strName==objItem.ItemName)
						{
							objPart.x = objItem.pos_X;
							objPart.y = objItem.pos_Y;
							break;
						}					
					}
				}
			}
		}
	}
}