﻿package classes.common
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.events.IOErrorEvent;
	import flash.text.*;
	import fl.controls.UIScrollBar;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	
	public class Exercise_Text extends Exercise
	{
		private const TEXT_BACKCOLOR_BASE:int = 0xEAE9ED;	//Text Background Base Color
		private const TEXT_COLOR_BASE:int = 0x425F9C;		//Text Base Color
		private var m_objTextForm:TextFormat;
		private var m_objOutText:TextField;
		private var m_objTextScr:UIScrollBar;
		private var m_objScript:MovieClip;

		//--------------------------------------------------------------------------
		//  Method:Exercise_Text
		//  Expranation: Constructor
		//	Parameter: 	val_sprBase			:Sprite	--- Sprite of Base
		//				val_sprParent		:Sprite	--- Sprite to add the menubar 
		//--------------------------------------------------------------------------	
		public function Exercise_Text(val_sprBase:Sprite,val_sprParent:Sprite)
		{
			super(val_sprBase,val_sprParent);
		}

		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get objScript():MovieClip
		{
			return m_objScript;
		}
		public function set objScript(val:MovieClip):void
		{
			m_objScript = val;
		}


		//--------------------------------------------------------------------------
		//  Method:setExercise_Copy
		//  Expranation: Set Text of reading exercise
		//	Parameter: 	strTxtURL		:String	--- Text URL
		//				strTxt			:String	--- Text
		//				objTxtFild		:TextField	--- TextField
		//--------------------------------------------------------------------------			
		public function setExercise_Copy(strTxtURL:String,strTxt:String,objTxtFild:TextField
										 ,objTxtScr:UIScrollBar=null):void
		{
			//* Set objects *//
			m_objOutText = objTxtFild;
			m_objOutText.border = true;
		  	m_objOutText.multiline = true;
		  	m_objOutText.wordWrap = true;
		  	m_objOutText.type = TextFieldType.DYNAMIC;
			m_objOutText.scrollH = 0;
			m_objOutText.scrollV = 1;
			//* Set Scrollbar *//
			if(objTxtScr!=null)
			{
				m_objTextScr = objTxtScr;
				with(m_objTextScr)
				{
					x = m_objOutText.x + m_objOutText.width;
					y = m_objOutText.y;
//					width = numScr_Width;
					height = m_objOutText.height;
		  			border = true;
				}				
			}			
			//* Set Text data *//
			if(strTxtURL!=""){setLoadText(strTxtURL);}
			else 
			{if(strTxt!=""){m_objOutText.text = strTxt;}}
		}
		
		//--------------------------------------------------------------------------
		//  Method:setExercise_Make
		//  Expranation: Set Text of reading exercise
		//	Parameter: 	strImgURL		:String	--- Image URL
		//				strImgName		:String	--- Image name
		//				pos_X			:Number	--- Position X
		//				pos_Y			:Number	--- Position Y
		//				numScale		:Number	--- Image size scale		
		//--------------------------------------------------------------------------			
		public function setExercise_Make(strTxtURL:String,strTxt:String,strTxtName:String
										 ,objTxtForm:TextFormat,numTxt_pos_X:Number,numTxt_pos_Y:Number
										 ,numTxt_Width:Number,numTxt_Height:Number,numScr_Width:Number
										 ,intBckClr:int=TEXT_BACKCOLOR_BASE,intTxtClr:int=TEXT_COLOR_BASE):void
		{
			//* Set objects *//
			m_objTextForm = objTxtForm;
			if(m_objOutText==null){m_objOutText = new TextField;}
			if(m_objTextScr==null){m_objTextScr = new UIScrollBar;}
			//Set text format
			with(m_objOutText)
			{
				m_objOutText.defaultTextFormat = objTxtForm;
				m_objOutText.name = "Read_Text";
				x = numTxt_pos_X;
				y = numTxt_pos_Y;
				textColor = intTxtClr;
				width = numTxt_Width;
				height = numTxt_Height;
				border = true;
				background = true;
				backgroundColor = intBckClr;
				multiline = true;
				wordWrap = true;
				type = TextFieldType.DYNAMIC;
			}
			objScript = new MovieClip;
			objScript.name = "Script"
			objScript.addChild(m_objOutText);
			//Set Scroll
			if(numScr_Width!=0)
			{
				with(m_objTextScr)
				{
					m_objTextScr.name = "Read_Scroll";
					x = numTxt_pos_X + numTxt_Width;
					y = numTxt_pos_Y;
					width = numScr_Width;
					height = numTxt_Height;
					border = true;
				}
				if(objScript==null){objScript = new MovieClip;}
				objScript.addChild(m_objTextScr);
			}
			//* Set Text data *//
			if(strTxtURL!=""){setLoadText(strTxtURL);}
			else 
			{if(strTxt!=""){m_objOutText.text = strTxt;}}
		}
		
		//--------------------------------------------------------------------------
		//  Method:setLoadSound
		//  Expranation: Setting for sound of loading
		//	Parameter: 	parentSound		:Object	--- paretn object of sound
		//				strSndURL		:String	--- Sound URL
		//				strSndName		:String	--- Sound object name
		//--------------------------------------------------------------------------	
		private function setLoadText(strTxtURL:String):void 
		{
			var loadText:URLLoader = new URLLoader();
			var request_Text:URLRequest = new URLRequest(strTxtURL);
			//Loading text
			loadText.load(request_Text);
			loadText.addEventListener(IOErrorEvent.IO_ERROR,onIOError,false,0,true);
			loadText.addEventListener(Event.COMPLETE,onCompleteLoad);
		}
		
		//--------------------------------------------------------------------------
		//  Method:onIOError
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------			
		private function onIOError(event:IOErrorEvent):void {
			trace("Error occurred when loading text:", event.text);
		}

		//--------------------------------------------------------------------------
		//  Method:onCompleteLoad
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------
		private function onCompleteLoad(event:Event):void 
		{
			m_objOutText.text = event.target.data;
			if(m_objTextScr!=null){m_objTextScr.scrollTarget = m_objOutText;}
		}
	}
}