﻿package classes.common
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.MovieClip;
	import flash.display.Loader;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.text.TextFormat;
	import flash.text.*;
	import flash.net.URLRequest;
	
	import classes.common.BaseStage;
	import classes.common.Static_Value;	
	import classes.common.Exercise;
	import classes.common.Exercise_Writing;
	import classes.common.Item;
	
	public class Exercise_Vocabulary extends Exercise
	{
		private	const ITEMS_BASE_POS_X:int = 0;
		private	const ITEMS_BASE_POS_Y:int = 0;
		private var m_arySprItems:Array = new Array();
		private var m_sprItems:Sprite;
		private var m_aryExercise:Array = new Array();
		private var m_aryExercise_Ans:Array = new Array();
		private var m_aryQuiz:Array = new Array();

		//--------------------------------------------------------------------------
		//  Method:Exercise_Vocabulary
		//  Expranation: Constructor
		//	Parameter: 	val_sprBase			:Sprite	--- Sprite of Base
		//				val_sprParent		:Sprite	--- Sprite to add the menubar 
		//--------------------------------------------------------------------------	
		public function Exercise_Vocabulary(val_sprBase:Sprite,val_sprParent:Sprite)
		{
			super(val_sprBase,val_sprParent);
		}
		
		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------


		//--------------------------------------------------------------------------
		//  methods:setExercise
		//  Expranation: To set  each excercise
		//	Parameter: 	strExcerciseType:	String 		--- Type of Excercise
		//				dict:				Dictionary 	--- Questions Data
		//--------------------------------------------------------------------------
		public function setExercise_Act1(intItemNum:int,aryItems_Mov:Array,aryItems_LargeMov:Array
										   ,aryItems_Txt:Array,aryItems_Nam:Array,aryItems_Snd:Array
										   ,objSelect:Object,numItemBasePos_X:Number,numItemBasePos_Y:Number
										   ,numTextBasePos_Y:Number,numItemDis_X:Number,numItemDis_Y:Number):void
		{
			//* Set items *//
			setContainerItems(Static_Value.VOC_ACT_1,intItemNum,aryItems_Mov
							   ,aryItems_LargeMov,aryItems_Txt,aryItems_Nam
							   ,aryItems_Snd,null,null
							   ,objSelect,numItemBasePos_X,numItemBasePos_Y
							   ,numTextBasePos_Y,numItemDis_X,numItemDis_Y
							   ,0,0);
			//-- Set previous and next button --//
			//if(aryItems_Mov.length>intItemNum){set_prev_next_Exercise();}
		}
		
		//--------------------------------------------------------------------------
		//  methods:setExercise
		//  Expranation: To set  each excercise
		//	Parameter: 	strExcerciseType:	String 		--- Type of Excercise
		//				dict:				Dictionary 	--- Questions Data
		//--------------------------------------------------------------------------
		public function setExercise_Act2(intItemNum:int,aryItems_Mov:Array,aryItems_LargeMov:Array
										   	,aryItems_Nam:Array,aryQuiz_Txt:Array,aryQuiz_Snd:Array
										   	,aryQuiz_Ans:Array,objSelect:Object,numItemBasePos_X:Number
									 		,numItemBasePos_Y:Number,numTextBasePos_X:Number,numTextBasePos_Y:Number
											,numItemDis_X:Number,numItemDis_Y:Number,strSpkURL:String="",numSpkBasePos_X:Number=0
											,numSpkBasePos_Y:Number=0):void
		{
			setContainerItems_Act2(Static_Value.VOC_ACT_2,intItemNum,aryItems_Mov
									,aryItems_LargeMov,aryItems_Nam,aryQuiz_Txt
									,aryQuiz_Snd,aryQuiz_Ans,objSelect
									,numItemBasePos_X,numItemBasePos_Y,numTextBasePos_X
									,numTextBasePos_Y,numItemDis_X,numItemDis_Y,strSpkURL,numSpkBasePos_X
									,numSpkBasePos_Y);	
			//-- Set previous and next button --//
			if(aryQuiz_Txt.length>1){set_prev_next_Exercise();}
		}

		//--------------------------------------------------------------------------
		//  Method:setContainerItems
		//  Expranation: Setting for the containers of the jobs
		//	Parameter: 	---  		
		//--------------------------------------------------------------------------
		private function setContainerItems(intTyp:int,intItemNum:int,aryItems_Mov:Array
										   ,aryItems_LargeMov:Array,aryItems_Txt:Array,aryItems_Nam:Array
										   ,aryItems_Snd:Array,aryItems_Ans:Array,aryItems_Ans_LowCase:Array
										   ,objSelect:Object,numItemBasePos_X:Number,numItemBasePos_Y:Number
										   ,numTextBasePos_Y:Number,numItemDis_X:Number,numItemDis_Y:Number
										   ,numChkBtnPos_X:Number,numChkBtnPos_Y:Number):void
		{
			const TEXTBOX_HEIGHT:Number = 37;
			const TEXTBOX_WIDTH:Number = 130;
			var intAdj_x:int = 0;
			var intAdj_y:int = 0;
			var intPage:int=0;
			var intItemTotal:int = aryItems_Mov.length;
			var aryItems:Array = new Array();
			var numTextBasePos_X:Number = numItemBasePos_X;
			var numTextDis_X:Number = numItemDis_X;
			var numTextDis_Y:Number = numItemDis_Y;
			var intNum:int = 0;
			//* Set items into pages *//
			m_arySprItems[intPage] = new Sprite;
			super.sprParent.addChild(m_arySprItems[intPage]);
			m_arySprItems[intPage].name = "Exercise_" + (intPage + 1).toString();
			m_arySprItems[intPage].x = ITEMS_BASE_POS_X; 
			m_arySprItems[intPage].y = ITEMS_BASE_POS_Y;			
			
			//--- Select ---//
			if(objSelect!=null)
			{
				aryItems[intItemTotal] = new Item(super.sprBase,m_arySprItems[intPage]);
				aryItems[intItemTotal].setDisplayItem(objSelect,"Select",null,"","",numItemBasePos_X,numItemBasePos_Y,false,null,false);
				aryItems[intItemTotal].addContainerItems(MouseEvent.CLICK,aryItems[intItemTotal].mouseClickEventHandler_Nothing);
			}
			//--- Items ---//			
			for(var i:int=0;i<intItemTotal; i++)
			{//-- Calculate item position --//
				if(i < intItemTotal/2)
				{
					intAdj_x = intNum;
					intAdj_y = 0;
					intNum = intNum + 1;
				}else if(i==intItemTotal/2){
					intNum = 0;
					intAdj_x = intNum;
					intAdj_y = 1;
					intNum = intNum + 1;
				}else{
					intAdj_x = intNum;
					intAdj_y = 1;
					intNum = intNum + 1;					
				}
				//-- Set item --//
				aryItems[i] = new Item(super.sprBase,m_arySprItems[intPage]);
				aryItems[i].setDisplayItem(aryItems_Mov[i],aryItems_Nam[i],aryItems_Snd[i]
											 ,"Sound_" + aryItems_Nam[i],"",numItemBasePos_X + numItemDis_X * intAdj_x
											 ,numItemBasePos_Y + numItemDis_Y * intAdj_y,true,aryItems_LargeMov[i],true);
				// --- Set Sound ---//
				if(aryItems_Snd!=null)
				{
					if(objSelect!=null){aryItems[i].addContainerItems(MouseEvent.CLICK,aryItems[i].mouseClickEventHandler_WithSound_LargePic,objSelect);}
					else{aryItems[i].addContainerItems(MouseEvent.CLICK,aryItems[i].mouseClickEventHandler_Playsound);}
				}
				else{aryItems[i].addContainerItems(MouseEvent.CLICK,aryItems[i].mouseClickEventHandler_Nothing);}
			}
		}

		//--------------------------------------------------------------------------
		//  Method:setContainerItems
		//  Expranation: Setting for the containers of the jobs
		//	Parameter: 	---  		
		//--------------------------------------------------------------------------
		private function setContainerItems_Act2(intTyp:int,intItemNum:int,aryItems_Mov:Array
										   		,aryItems_LargeMov:Array,aryItems_Nam:Array
										   		,aryQuiz_Txt:Array,aryQuiz_Snd:Array,aryQuiz_Ans:Array
												,objSelect:Object,numItemBasePos_X:Number,numItemBasePos_Y:Number
												,numTextBasePos_X:Number,numTextBasePos_Y:Number,numItemDis_X:Number
												,numItemDis_Y:Number,strSpkURL:String,numSpkBasePos_X:Number
												,numSpkBasePos_Y:Number):void
		{
			const KEY_QUIZ:String = "Exercise_";
			//const TEXTBOX_HEIGHT:Number = 37;
			//const TEXTBOX_WIDTH:Number = 130;
			
			var intAdj_x:int = 0;
			var intAdj_y:int = 0;
			var intPage:int=0;
			var intItemTotal:int = aryItems_Mov.length;
			var aryItems:Array = new Array();
			//var numTextBasePos_X:Number = numItemBasePos_X;
			var intNum:int = 0;
			//* Set items into pages *//
			//m_sprItems = super.sprParent;
			m_sprItems = new Sprite;
			super.sprParent.addChild(m_sprItems);
			m_sprItems.name = KEY_QUIZ;  // + (intPage + 1).toString();
			m_sprItems.x = ITEMS_BASE_POS_X; 
			m_sprItems.y = ITEMS_BASE_POS_Y;			
			m_aryExercise_Ans = new Array;
			m_aryExercise_Ans = aryQuiz_Ans;
			
			//--- Select ---//
			if(objSelect!=null)
			{
				aryItems[intItemTotal] = new Item(super.sprBase,m_sprItems);
				aryItems[intItemTotal].setDisplayItem(objSelect,"Select",null,"","",numItemBasePos_X,numItemBasePos_Y,false,null,false);
				aryItems[intItemTotal].addContainerItems(MouseEvent.CLICK,aryItems[intItemTotal].mouseClickEventHandler_Nothing);
			}
			//--- Items Answers ---//
			var i:int=0
			for(i=0;i<intItemTotal; i++)
			{	//-- Calculate item position --//
				if(i < intItemTotal/2)
				{
					intAdj_x = intNum;
					intAdj_y = 0;
					intNum = intNum + 1;
				}else if(i==intItemTotal/2){
					intNum = 0;
					intAdj_x = intNum;
					intAdj_y = 1;
					intNum = intNum + 1;
				}else{
					intAdj_x = intNum;
					intAdj_y = 1;
					intNum = intNum + 1;					
				}
				//-- Set item --//
				aryItems[i] = new Item(super.sprBase,m_sprItems);
				aryItems[i].setDisplayItem(aryItems_Mov[i],aryItems_Nam[i],null
											 ,"","",numItemBasePos_X + numItemDis_X * intAdj_x
											 ,numItemBasePos_Y + numItemDis_Y * intAdj_y,true,aryItems_LargeMov[i],true);
				aryItems[i].addContainerItems(MouseEvent.CLICK,mouseClickEventHandler_ChkVal);
			}
			//--- Items Quiz ---//
			var objTmp:Item;
			var strName:String;
			//*--- Add the Quizes ---*//
			for(i=0;i<aryQuiz_Txt.length; i++)
			{
				var blnVisible:Boolean = false;
				if(i==0){blnVisible=true;}else{blnVisible=false;}
				m_aryQuiz[i] = new Item(super.sprBase,m_sprItems);
				m_aryQuiz[i].setDisplayItem(aryQuiz_Txt[i],KEY_QUIZ + (i+1).toString(),aryQuiz_Snd[i]
											 ,"Sound_"  + (i+1).toString(),"",numTextBasePos_X
											 ,numTextBasePos_Y,blnVisible,null,true);
				m_aryQuiz[i].addContainerItems(MouseEvent.CLICK,m_aryQuiz[i].mouseClickEventHandler_Playsound);
				if(strSpkURL!="")
				{
					var objSpk = objLoader(strSpkURL);
					objSpk.name = "Speaker";
					objSpk.x = numSpkBasePos_X;
					objSpk.y = numSpkBasePos_Y;
					m_sprItems.addChild(objSpk);
				}
			}
		}

		//--------------------------------------------------------------------------
		//  Method:set_prev_next_Exercise
		//  Expranation: Create main cumpus
		//	Parameter: 	---	
		//--------------------------------------------------------------------------
		private function set_prev_next_Exercise()
		{
			//-- Set previous and next button --//
			super.setExerciseInfo(m_aryQuiz.length,"Vocabulary");
			trace("Static_Value.EXERCISE_BTN_PRE_NEXT_Y:" + Static_Value.EXERCISE_BTN_PRE_NEXT_Y);
			trace("super.sprParent.y:" + super.sprParent.y);
			super.create_prev_next(null,0,Static_Value.EXERCISE_BTN_PRE_NEXT_Y - super.sprParent.y);
			super.setScreen(null,m_aryQuiz[0].objMovieClip,m_aryQuiz[1].objMovieClip);			
		}

		//--------------------------------------------------------------------------
		//  Method:mouseClickEventHandler_ChkVal
		//  Expranation: mouseClick event to return value
		//	Parameter: 	event		:MouseEvent	---  		
		//--------------------------------------------------------------------------	
		private function mouseClickEventHandler_ChkVal(event:Event):void
		{		
			const CORRECT:Boolean = true;
			const INCORRECT:Boolean = false;
			const MSG_ON:Boolean = true;
			const MSG_OFF:Boolean = false;			
			const SOUND_ON:Boolean = true;
			const SOUND_OFF:Boolean = false;

			var objTarget = event.target;
			trace("obj.name:" + objTarget.name);
			trace("m_aryExercise_Ans:" + m_aryExercise_Ans[super.intCurrentPage - 1]);
			trace("super.m_intCurrentPage:" + super.intCurrentPage);					
			super.objInstructor.stopSound();
			try 
			{
				if (objTarget.name==m_aryExercise_Ans[super.intCurrentPage - 1].toString()) 
				{
					//super.intCntCorrect = super.intCntCorrect + 1;
					//objTarget.removeEventListener(MouseEvent.CLICK,mouseClickEventHandler_ChkVal);
					super.showMsg(CORRECT,MSG_ON,SOUND_ON);
					//super.changePage();
				}
				else 
				{
					super.showMsg(INCORRECT,MSG_ON,SOUND_ON,INCORRECT);
				}
			}
			catch (error:Error)
			{
   				//Alert.show(error.Message);
				var errorMessage:TextField = new TextField(); 
				errorMessage.autoSize = TextFieldAutoSize.LEFT; 
				errorMessage.textColor = 0xFF0000; 
				errorMessage.text = error.message; 
				super.sprParent.addChild(errorMessage); 
			}
			finally
			{
   			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:objLoader
		//  Expranation: URLRequest Loader
		//	Parameter: 	---  		
		//--------------------------------------------------------------------------	
		private function objLoader(strURL:String):Object
		{
			var objLoader:Loader = null;
			try 
			{
				//** URL Load **//
				var objURL:URLRequest = new URLRequest(strURL)
				objLoader = new Loader();
				objLoader.load(objURL);
			}
			catch (error:Error)
			{
   				//Alert.show(error.Message);
				var errorMessage:TextField = new TextField(); 
				errorMessage.autoSize = TextFieldAutoSize.LEFT; 
				errorMessage.textColor = 0xFF0000; 
				errorMessage.text = error.message; 
				super.sprParent.addChild(errorMessage); 
			}
			finally
			{
				return objLoader;
   			}
		}		
	}
}