﻿package classes.common
{
	import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.text.*;
	
	public class Exercise_Writing extends Exercise
	{
		//super.aryAnswers[count][0]:answer	
		//super.aryAnswers[count][1]:textbox_pos_X	
		//super.aryAnswers[count][2]:textbox_pos_Y
		//super.aryAnswers[count][3]:textbox_height
		//super.aryAnswers[count][4]:textbox_width
		//super.aryAnswers[count][5]:chkBtn_pos_X
		//super.aryAnswers[count][6]:chkBtn_pos_Y		
		private var m_objTextForm:TextFormat;
		private var m_numBtnChkPos_X:Number;

		//--------------------------------------------------------------------------
		//  Method:Exercise_Writing
		//  Expranation: Constructor
		//	Parameter: 	val_sprBase			:Sprite	--- Sprite of Base
		//				val_sprParent		:Sprite	--- Sprite to add the menubar 
		//--------------------------------------------------------------------------	
		public function Exercise_Writing(val_sprBase:Sprite,val_sprParent:Sprite)
		{
			super(val_sprBase,val_sprParent);
		}

		//--------------------------------------------------------------------------
		//  Getter/Setter
		//--------------------------------------------------------------------------
		public function get objTextForm():TextFormat
		{
			return m_objTextForm;
		}
		public function set objTextForm(val:TextFormat):void
		{
			m_objTextForm = val;
		}

		public function get numBtnChkPos_X():Number
		{
			return m_numBtnChkPos_X;
		}
		public function set numBtnChkPos_X(val:Number):void
		{
			m_numBtnChkPos_X = val;
		}

		//--------------------------------------------------------------------------
		//  methods:setExercise
		//  Expranation: To set  each excercise
		//	Parameter: 	strExcerciseType:	String 		--- Type of Excercise
		//				dict:				Dictionary 	--- Questions Data
		//--------------------------------------------------------------------------
		public function setExercise(intPages:int,strExcerciseType:String,objSample:TextFormat
									,answer:Array=null,blnBtnLarge:Boolean=true):void
		{
			objTextForm = objSample;
			super.setExerciseInfo(intPages,strExcerciseType);
//			super.setNextPrvButton();
//			super.setScreen(objPrevious,objCurrent,objNext);
			if(answer!=null)
			{
				super.aryAnswers = answer;
				super.intCntCorrect = 0;
				if(strExcerciseType=="Writing"){setExerciseWriting(blnBtnLarge);}
				else if(strExcerciseType=="Writing_OneChk"){setExerciseWriting_OneChk();}
			}
			else
			{
				trace("Writing: Questions = 0...");
			}
		}

		//--------------------------------------------------------------------------
		//  methods:setExerciseWriting
		//  Expranation: To set exercises DragAndDrop
		//	Parameter: 	blnBtnLarge:	Boolean 	--- Type of button
		//--------------------------------------------------------------------------
		private function setExerciseWriting(blnBtnLarge:Boolean) 
		{
			var count:uint = 0;
			var aryEntreeUtil:Array = [];
			//trace("super.aryAnswers.length:" + super.aryAnswers.length);
			for each (var item in super.aryAnswers)
			{	
				//create answer fields//
				aryEntreeUtil[count] = new TextField();
				aryEntreeUtil[count].type = TextFieldType.INPUT; 
				//set format of answer fields//
				var formatEntree:TextFormat = new TextFormat(); 
				formatEntree.font = objTextForm.font;
				formatEntree.size = objTextForm.size;
				formatEntree.align = TextFormatAlign.CENTER;
				//set answer fields//
				aryEntreeUtil[count].defaultTextFormat = formatEntree;
				aryEntreeUtil[count].name = "EntreeUtil" + count;
				aryEntreeUtil[count].x = item[2]; 
				aryEntreeUtil[count].y = item[3];
				aryEntreeUtil[count].height = item[4];
				aryEntreeUtil[count].width = item[5];
				aryEntreeUtil[count].border = true;
				super.sprParent.addChild(aryEntreeUtil[count]);
				//stage.focus = aryEntreeUtil[count]; //La propriété "focus", fait en sorte que le curseur soit dans la case créée
				//create check button//
				var tmpChkBtn:BaseButton = super.createCheckButton(item[6],item[7] - 1,1.0,exerciseTypeConfirmClickHandler,blnBtnLarge);
				//tmpChkBtn.y = aryEntreeUtil[count].y;
				tmpChkBtn.name = "ChkBtn" + count;
				tmpChkBtn.objInputText_Answer = item[0];
				tmpChkBtn.blnInputText_Answer_LowCase = item[1];				
				tmpChkBtn.objInputText = aryEntreeUtil[count];
				super.sprParent.addChild(tmpChkBtn);
				count = count + 1;
			}
			super.intCntQuestion = count;
		}	
		
		//--------------------------------------------------------------------------
		//  methods:exerciseTypeConfirmClickHandler
		//  Expranation: To set exercises DragAndDrop
		//	Parameter: 	event:				MouseEvent 	--- Mouse_CLICK event
		//--------------------------------------------------------------------------
		private function exerciseTypeConfirmClickHandler(event:MouseEvent):void
		{
			const CORRECT:Boolean = true;
			const INCORRECT:Boolean = false;
			const INCORRECT_SPELL:Boolean = true;
			const MSG_ON:Boolean = true;
			const MSG_OFF:Boolean = false;			
			const SOUND_ON:Boolean = true;
			const SOUND_OFF:Boolean = false;	
			var objTarget = event.target.parent;
			var entryUtilisateur:String;
			
			// Set Input data
			if(objTarget.blnInputText_Answer_LowCase){entryUtilisateur = objTarget.objInputText.text.toLowerCase();} //récupération du texte saisi par l'utlilisateur
			else {entryUtilisateur = objTarget.objInputText.text;}
			super.objInstructor.stopSound();
			try 
			{
				if (trim(entryUtilisateur)==objTarget.objInputText_Answer) 
				{
					super.intCntCorrect = super.intCntCorrect + 1;
					objTarget.removeEventListener(MouseEvent.CLICK,exerciseTypeConfirmClickHandler);
					objTarget.visible = false;
					objTarget.objInputText.type = TextFieldType.DYNAMIC;
					super.showMsg(CORRECT,MSG_ON,SOUND_ON);
					super.changePage();
				}
				else 
				{
					if(objTarget.blnInputText_Answer_LowCase){super.showMsg(INCORRECT,MSG_ON,SOUND_ON,INCORRECT);}
					else{super.showMsg(INCORRECT,MSG_ON,SOUND_ON,INCORRECT_SPELL);}
				}
			}
			catch (error:Error)
			{
   				//Alert.show(error.Message);
				var errorMessage:TextField = new TextField(); 
				errorMessage.autoSize = TextFieldAutoSize.LEFT; 
				errorMessage.textColor = 0xFF0000; 
				errorMessage.text = error.message; 
				super.sprParent.addChild(errorMessage); 
			}
			finally
			{
   			}
		}

		//--------------------------------------------------------------------------
		//  methods:setExerciseWriting_OneChk
		//  Expranation: To set exercises DragAndDrop
		//	Parameter: 		---
		//--------------------------------------------------------------------------
		private function setExerciseWriting_OneChk() 
		{
			var count:uint = 0;
			var aryEntreeUtil:Array = [];
			var tmpChkBtn:BaseButton;
			var blnExist:Boolean = false;
			for each (var item in super.aryAnswers)
			{	
				//create answer fields//
				aryEntreeUtil[count] = new TextField();
				aryEntreeUtil[count].type = TextFieldType.INPUT; 
				//set format of answer fields//
				var formatEntree:TextFormat = new TextFormat(); 
				formatEntree.font = objTextForm.font;
				formatEntree.size = objTextForm.size;
				formatEntree.align = TextFormatAlign.CENTER;
				//set answer fields//
				aryEntreeUtil[count].defaultTextFormat = formatEntree;
				aryEntreeUtil[count].name = "EntreeUtil" + count;
				aryEntreeUtil[count].x = item[2]; 
				aryEntreeUtil[count].y = item[3];
				aryEntreeUtil[count].height = item[4];
				aryEntreeUtil[count].width = item[5];
				aryEntreeUtil[count].border = true;
				super.sprParent.addChild(aryEntreeUtil[count]);
				//stage.focus = aryEntreeUtil[count]; //La propriété "focus", fait en sorte que le curseur soit dans la case créée
				//create check button//
				if(blnExist==false)
				{
					tmpChkBtn = super.createCheckButton(item[6],item[7],1.0,exerciseTypeConfirmClickHandler_OneChk);
					blnExist = true;
					tmpChkBtn.name = "ChkBtn" + count;
					tmpChkBtn.aryInputText = new Array ();
					tmpChkBtn.aryInputText_Answer = new Array ();
					tmpChkBtn.aryInputText_Answer_LowCase = new Array ();
					super.sprParent.addChild(tmpChkBtn);
				}
				tmpChkBtn.aryInputText_Answer[count] = item[0];
				tmpChkBtn.aryInputText_Answer_LowCase[count] = item[1];				
				tmpChkBtn.aryInputText[count] = aryEntreeUtil[count];
//				trace("item[0]:" + item[0]);
//				trace("item[1]:" + item[1]);
//				trace("aryEntreeUtil[count]:" + aryEntreeUtil[count]);
				count = count + 1;
			}
			super.intCntQuestion = count;
		}

		//--------------------------------------------------------------------------
		//  methods:exerciseTypeConfirmClickHandler_OneChk
		//  Expranation: To set exercises DragAndDrop
		//	Parameter: 	event:				MouseEvent 	--- Mouse_CLICK event
		//--------------------------------------------------------------------------
		private function exerciseTypeConfirmClickHandler_OneChk(event:MouseEvent):void
		{
			const CORRECT:Boolean = true;
			const INCORRECT:Boolean = false;
			const INCORRECT_SPELL:Boolean = true;
			const MSG_ON:Boolean = true;
			const MSG_OFF:Boolean = false;			
			const SOUND_ON:Boolean = true;
			const SOUND_OFF:Boolean = false;
			const TEXT_COLOR_GRN:int = 0x009900;//0x00FF00;
			const TEXT_COLOR_RED:int = 0xFF0000;
			var objTarget = event.target.parent;
			var entryUtilisateur:String;
			
			super.objInstructor.stopSound();
			try 
			{
				for(var i:int=0;i<objTarget.aryInputText_Answer.length; i++)
				{
					// Set Input data
					if(objTarget.aryInputText_Answer_LowCase[i])
					{entryUtilisateur = objTarget.aryInputText[i].text.toLowerCase();}
					else{entryUtilisateur = objTarget.aryInputText[i].text;}
					// Check Input data
//					trace("entryUtilisateur:" + entryUtilisateur);
//					trace("objTarget.aryInputText_Answer[i]:" + objTarget.aryInputText_Answer[i]);
					if (trim(entryUtilisateur)==objTarget.aryInputText_Answer[i]) 
					{
						super.intCntCorrect = super.intCntCorrect + 1;
						objTarget.aryInputText[i].textColor = TEXT_COLOR_GRN;
						objTarget.aryInputText[i].type = TextFieldType.DYNAMIC;
					}
					else 
					{
						objTarget.aryInputText[i].textColor = TEXT_COLOR_RED;
					}
				}
				// Show the message
				if(super.intCntCorrect==objTarget.aryInputText_Answer.length)
				{
					objTarget.removeEventListener(MouseEvent.CLICK,exerciseTypeConfirmClickHandler_OneChk);
					objTarget.visible = false;						
					super.showMsg(CORRECT,MSG_ON,SOUND_ON);
					super.changePage();
				}
				else
				{
					if(objTarget.aryInputText_Answer_LowCase[i]){super.showMsg(INCORRECT,MSG_ON,SOUND_ON,INCORRECT);}
					else{super.showMsg(INCORRECT,MSG_ON,SOUND_ON,INCORRECT_SPELL);}
					super.intCntCorrect = 0;
				}
			}
			catch (error:Error)
			{
   				//Alert.show(error.Message);
				var errorMessage:TextField = new TextField(); 
				errorMessage.autoSize = TextFieldAutoSize.LEFT; 
				errorMessage.textColor = 0xFF0000; 
				errorMessage.text = error.message; 
				super.sprParent.addChild(errorMessage); 
			}
			finally
			{
   			}
		}
		
		//--------------------------------------------------------------------------
		//  methods:ltrim
		//  Expranation: To remove space from left side
		//	Parameter: 	strData:	String 	--- string to be trimmed
		//--------------------------------------------------------------------------	
		private function ltrim(strData) 
		{
		    if ((strData.length>1) || (strData.length==1 && strData.charCodeAt(0)>32 && strData.charCodeAt(0)<255))
			{
				var i = 0;
				while (i<strData.length && (strData.charCodeAt(i)<=32 || strData.charCodeAt(i)>=255)){i++;}
				strData = strData.substring(i);
			}
			else{strData = "";}
			return strData;
		}

		//--------------------------------------------------------------------------
		//  methods:ltrim
		//  Expranation: To remove space from right side
		//	Parameter: 	strData:	String 	--- string to be trimmed
		//--------------------------------------------------------------------------	
		private function rtrim(strData) 
		{
			if ((strData.length>1) || (strData.length==1 && strData.charCodeAt(0)>32 && strData.charCodeAt(0)<255)) 
			{
				var i = strData.length-1;
//				trace("strData:" + strData);
//				for(var j:int=0;j<strData.length; j++){trace("strData.charCodeAt(i):" + strData.charCodeAt(j));}
				while (i>=0 && (strData.charCodeAt(i)<=32 || strData.charCodeAt(i)>=255)){i--;}
				strData = strData.substring(0,i+1);
			}
			else{strData = "";}
			return strData;
		}
		
		//--------------------------------------------------------------------------
		//  methods:ltrim
		//  Expranation: To remove space from both sides
		//	Parameter: 	strData:	String 	--- string to be trimmed
		//--------------------------------------------------------------------------	
		private function trim(strData)
		{
			return ltrim(rtrim(strData));
		}
	}
}