﻿package  classes.common
{
	import flash.display.Sprite;
	import flash.display.MovieClip;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.*;
	import classes.common.Static_Value;
	
	public class Item
	{
		public static var isPlaying:Boolean = false;
		
		private var m_sprBase:Sprite;
		private var m_sprParent:Sprite;
		private var m_objMovieClip:MovieClip;
		private var m_objMovieClipText:MovieClip;	
		private var m_objSelect:MovieClip;
		private var m_objSound:Sound;
		private var m_strSound:String;
		private var m_strURL:String;
		private var m_numSndPosition:Number = 0;
		private var m_sndChannel:SoundChannel;
		private var m_objSelectItem:Item;
		private var m_objLargeMovieClip:MovieClip;
		private var m_ItemName:String;
		private var m_pos_X:Number = 0;
		private var m_pos_Y:Number = 0;

		private static  const SOUND_ON:Boolean = true;				
		private static  const SOUND_OFF:Boolean = false;
		private static  const KEY_LARGE_PIC:String = "Large_";

		//--------------------------------------------------------------------------
		//  Method:Item
		//  Expranation: Item
		//	Parameter: 	val_sprBase:	Sprite --- Main base sprite
		//				val_sprParent:	Sprite --- Parent sprite
		//--------------------------------------------------------------------------		
		public function Item(val_sprBase:Sprite,val_sprParent:Sprite) 
		{
			this.sprBase = val_sprBase;
			this.sprParent = val_sprParent;
		}

		//--------------------------------------------------------------------------
		//  gettet/setter
		//--------------------------------------------------------------------------	
		public function get sprBase():Sprite
		{
			return m_sprBase;
		}
		public function set sprBase(val:Sprite):void
		{
			m_sprBase = val;
		}	
		
		public function get sprParent():Sprite
		{
			return m_sprParent;
		}
		public function set sprParent(val:Sprite):void
		{
			m_sprParent = val;
		}	
		
		public function get objMovieClip():MovieClip
		{
			return m_objMovieClip;
		}
		public function set objMovieClip(val:MovieClip):void
		{
			m_objMovieClip = val;
		}		

		public function get objMovieClipText():MovieClip
		{
			return m_objMovieClipText;
		}
		public function set objMovieClipText(val:MovieClip):void
		{
			m_objMovieClipText = val;
		}		

		public function get objSelect():MovieClip
		{
			return m_objSelect;
		}		
		public function set objSelect(val:MovieClip):void
		{
			m_objSelect = val;
		}
		
		public function get objSound():Sound
		{
			return m_objSound;
		}		
		public function set objSound(val:Sound):void
		{
			m_objSound = val;
		}

		public function get strSound():String
		{
			return m_strSound;
		}		
		public function set strSound(val:String):void
		{
			m_strSound = val;
		}
		
		public function get numSndPosition():Number
		{
			return m_numSndPosition;
		}		
		public function set numSndPosition(val:Number):void
		{
			m_numSndPosition = val;
		}		

		public function get sndChannel():SoundChannel
		{
			return m_sndChannel;
		}		
		public function set sndChannel(val:SoundChannel):void
		{
			m_sndChannel = val;
		}

		public function get strURL():String
		{
			return m_strURL;
		}		
		public function set strURL(val:String):void
		{
			m_strURL = val;
		}

		public function get objLargeMovieClip():MovieClip
		{
			return m_objLargeMovieClip;
		}
		public function set objLargeMovieClip(val:MovieClip):void
		{
			m_objLargeMovieClip = val;
		}

		public function get ItemName():String
		{
			return m_ItemName;
		}		
		public function set ItemName(val:String):void
		{
			m_ItemName = val;
		}
		
		public function get pos_X():Number
		{
			return m_pos_X;
		}		
		public function set pos_X(val:Number):void
		{
			m_pos_X = val;
		}				

		public function get pos_Y():Number
		{
			return m_pos_Y;
		}		
		public function set pos_Y(val:Number):void
		{
			m_pos_Y = val;
		}				

		//--------------------------------------------------------------------------
		//  methods:setDisplayItem
		//  Expranation: To set item information
		//	Parameter: 	objMovieClip:	Object --- Item image Data
		//				strMovieClip:	String --- Item name
		//				objSound:		Object --- Item sound (pronunciation)
		//				strSound:		String --- Item sound name
		//				strURL:			String --- URLRequest Loader name
		//				valX:			Number --- Item image position
		//				valY:			Number --- Item image position	
		//				blnVisible:		Boolean --- Item image visible
		//				blnMouseEnable:	Boolean --- Item image MouseEnable		
		//  Return:		Void
		//--------------------------------------------------------------------------		
		public function setDisplayItem(objMovieClip:Object,strMovieClip:String,objSound:Object
							   			,strSound:String,strURL:String,valX:Number
										,valY:Number,blnVisible:Boolean,objLargeMovieClip:Object=null
										,blnMouseEnable:Boolean=true)
		{
			if(strMovieClip!=null)
			{
				this.objMovieClip = new objMovieClip as MovieClip;
				this.objMovieClip.name = strMovieClip;
			}
			if(objSound!=null)
			{
				this.objSound = new objSound;
				this.strSound = strSound;
				this.objMovieClip.useHandCursor = true;
			}
			if(objLargeMovieClip!=null)
			{
				this.objLargeMovieClip = new objLargeMovieClip as MovieClip;
				this.objLargeMovieClip.name = KEY_LARGE_PIC + strMovieClip;
				this.objLargeMovieClip.x = Static_Value.VOC_LARGE_PIC_BASE_POS_X;
				this.objLargeMovieClip.y = Static_Value.VOC_LARGE_PIC_BASE_POS_Y;
				this.objLargeMovieClip.visible = false;
				this.objLargeMovieClip.addEventListener(MouseEvent.CLICK,hideLargePic);
			}
			this.strURL = strURL;
			this.objMovieClip.x = valX;
			this.objMovieClip.y = valY;
			this.objMovieClip.visible = blnVisible;
			this.objMovieClip.mouseEnabled = blnMouseEnable;
			
		}

		//--------------------------------------------------------------------------
		//  methods:setDisplayItem
		//  Expranation: To set item information
		//	Parameter: 	objMovieClipText:	Object --- Item image Data
		//				strMovieClip:	String --- Item name
		//				valX:			Number --- Item image position
		//				valY:			Number --- Item image position	
		//				blnVisible:		Boolean --- Item image visible
		//				blnMouseEnable:	Boolean --- Item image MouseEnable		
		//  Return:		Void
		//--------------------------------------------------------------------------		
		public function setDisplayItemText(objMovieClipText:Object,strMovieClip:String,valX:Number
											,valY:Number,blnVisible:Boolean,blnMouseEnable:Boolean=true)
		{
			if(strMovieClip!=null)
			{
				this.objMovieClipText = new objMovieClipText as MovieClip;
				this.objMovieClipText.name = strMovieClip;
			}
			this.objMovieClipText.x = valX;
			this.objMovieClipText.y = valY;
			this.objMovieClipText.visible = blnVisible;
			this.objMovieClipText.mouseEnabled = blnMouseEnable;
		}
		
		//--------------------------------------------------------------------------
		//  Method:addContainerItems
		//  Expranation: Add items into the parent container with events
		//	Parameter: 	mouse_event		:String	--- event to add into the item
		//				event_function	:Item	--- event function for upper event
		//--------------------------------------------------------------------------
/*		public function addContainerItems(blnSound:Boolean,blnLoader:Boolean)
		{
			if(blnSound)
			{
				this.objMovieClip.addEventListener(MouseEvent.CLICK,mouseOverEventHandler_Loader);
			}
			if(blnLoader)
			{
				this.objMovieClip.addEventListener(MouseEvent.CLICK,mouseClickEventHandler_Loader);
			}
			
			sprParent.addChild(this.objMovieClip);
		}
*/
		public function addContainerItems(mouse_event:String,event_function:Function,objSelect:Object=null)
		{
			//** Set the object_Select **//
			var i:int;
			for(i=0;i<sprParent.numChildren;i++)
			{
				var obj:DisplayObject = sprParent.getChildAt(i);
				if(obj.name == "Select")
				{
					this.objSelect = obj as MovieClip;
					break;
				}
			}

//			if(objSelect!=null)
//			{
//				var obj = new objSelect();
//				obj.name == "Select"
//				this.objSelect = obj;
//			}
			if(mouse_event!="")
			{
				this.objMovieClip.addEventListener(mouse_event,event_function);
				//this.objMovieClipText.addEventListener(mouse_event,event_function);
			}			
			if(this.objMovieClip!=null){sprParent.addChild(this.objMovieClip);}
			if(this.objMovieClipText!=null){sprParent.addChild(this.objMovieClipText);}
			if(this.objLargeMovieClip!=null){sprParent.addChild(this.objLargeMovieClip);}
			if(this.objSelect!=null){sprParent.addChild(this.objSelect);}
		}

		//--------------------------------------------------------------------------
		//  Method:mouseEvent_Loader
		//  Expranation: URLRequest Loader
		//	Parameter: 	---  		
		//--------------------------------------------------------------------------	
		private function mouseEvent_Loader():void
		{
			//** URL Load **//
			var objURL:URLRequest = new URLRequest(this.strURL)
			var objLoader:Loader = new Loader();
			sprBase.visible = false;
			objLoader.load(objURL);
			sprBase.parent.addChild(objLoader);
		}

		//--------------------------------------------------------------------------
		//  Method:mouseClickEventHandler_Playsound
		//  Expranation: mouseDownEvent
		//	Parameter: 	event		:MouseEvent	---  		
		//--------------------------------------------------------------------------	
		public function mouseClickEventHandler_Playsound(event:Event):void
		{
			stopSound();
			if(!isPlaying)
			{
				isPlaying = true;
				if(objSound!=null)
				{
					sndChannel = objSound.play(numSndPosition);
					sndChannel.addEventListener(Event.SOUND_COMPLETE,onPlayComplete,false,0,true);
				}
			}
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseClickEventHandler_WithSound
		//  Expranation: mouseDownEvent
		//	Parameter: 	event		:MouseEvent	---  		
		//--------------------------------------------------------------------------	
		public function mouseClickEventHandler_WithSound(event:Event):void
		{
			//** Move Select symbol **//
			moveSelectWithSound(SOUND_ON);
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseClickEventHandler_WithoutSound
		//  Expranation: mouseDownEvent
		//	Parameter: 	event		:MouseEvent	---  		
		//--------------------------------------------------------------------------	
		public function mouseClickEventHandler_WithoutSound(event:Event):void
		{
			//** Move Select symbol **//
			moveSelectWithSound(SOUND_OFF);
		}

		//--------------------------------------------------------------------------
		//  Method:mouseClickEventHandler_WithoutSound_LargePic
		//  Expranation: mouseDownEvent
		//	Parameter: 	event		:MouseEvent	---  		
		//--------------------------------------------------------------------------	
		public function mouseClickEventHandler_WithSound_LargePic(event:Event):void
		{
			//** Move Select symbol **//
			moveSelectWithSound(SOUND_ON);
			showLargePic();
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseClickEventHandler_LoaderWithSound
		//  Expranation: mouseDownEvent
		//	Parameter: 	event		:MouseEvent	---  		
		//--------------------------------------------------------------------------	
		public function mouseClickEventHandler_LoaderWithSound(event:Event):void
		{
			//** Move Select symbol **//
			moveSelectWithSound(SOUND_ON);
			//** URLRequest Loader **//
			mouseEvent_Loader();
		}
		
		//--------------------------------------------------------------------------
		//  Method:mouseClickEventHandler_LoaderWithoutSound
		//  Expranation: mouseDownEvent
		//	Parameter: 	event		:MouseEvent	---  		
		//--------------------------------------------------------------------------	
		public function mouseClickEventHandler_LoaderWithoutSound(event:Event):void
		{
			//** Move Select symbol **//
			moveSelectWithSound(SOUND_OFF);
			//** URLRequest Loader **//
			mouseEvent_Loader();
		}

		//--------------------------------------------------------------------------
		//  Method:mouseOverEventHandler_WithSound
		//  Expranation: mouseDownEvent
		//	Parameter: 	event		:MouseEvent	---  		
		//--------------------------------------------------------------------------	
		public function mouseOverEventHandler_WithSound(event:Event):void
		{
			//** Move Select symbol **//
			stopSound();
			moveSelectWithSound(SOUND_ON);
		}

		//--------------------------------------------------------------------------
		//  Method:mouseOverEventHandler_WithoutSound
		//  Expranation: mouseDownEvent
		//	Parameter: 	event		:MouseEvent	---  		
		//--------------------------------------------------------------------------	
		public function mouseOverEventHandler_WithoutSound(event:Event):void
		{
			//** Move Select symbol **//
			moveSelectWithSound(SOUND_OFF);
		}

		//--------------------------------------------------------------------------
		//  Method:moveSelectWithSound
		//  Expranation: move "Select" symbol to cover the target item
		//	Parameter: 	blnOnOff	:Boolean	--- Sound on or off
		//				objItem		:Object	--- Target item
		//				objParent	:Object	--- Target container
		//				objSelect	:Object	--- "Select" symbol
		//--------------------------------------------------------------------------	
		private function moveSelectWithSound(blnOnOff:Boolean):void
		{
			//** Move the object on the selected object **//
			stopSound();
			sprParent.setChildIndex(objSelect,sprParent.numChildren-1);	//move front
			objSelect.visible = true;
			objSelect.x = objMovieClip.x;
			objSelect.y = objMovieClip.y;
			//** Play Sound **//
			if(blnOnOff)
			{				
				if(!isPlaying) 
				{
					isPlaying = true;
					if(objSound!=null)
					{
//						trace("numSndPosition:" + numSndPosition);
//						trace("objSound:" + objSound);
						sndChannel = objSound.play(numSndPosition);
						sndChannel.addEventListener(Event.SOUND_COMPLETE,onPlayComplete,false,0,true);
					}
				}
/*				
				if(sndChannel) 
				{
					sndChannel = objSound.play(sndChannel.position);
				}
				else 
				{
					sndChannel = objSound.play();
				}
				sndChannel.addEventListener(Event.SOUND_COMPLETE,onSoundCompleted);
				objSound.play(0,1);
*/	
			}
		}

		//--------------------------------------------------------------------------
		//  Method:mouseClickEventHandler_Nothing
		//  Expranation: mouseDownEvent
		//	Parameter: 	event		:MouseEvent	---  		
		//--------------------------------------------------------------------------	
		public function mouseClickEventHandler_Nothing(event:Event):void
		{
		}

		//--------------------------------------------------------------------------
		//  Method:onPlayComplete
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------	
		private function onPlayComplete(event:Event):void 
		{
			sndChannel.removeEventListener(Event.SOUND_COMPLETE,onPlayComplete);
			sndChannel.stop();
			numSndPosition = 0;
			isPlaying = false;
		}
	
		//--------------------------------------------------------------------------
		//  Method:stopSound
		//  Expranation: Event
		//	Parameter: 	event		:Event	---  		
		//--------------------------------------------------------------------------	
		public function stopSound():void 
		{
			if(sndChannel!=null)
			{
				sndChannel.removeEventListener(Event.SOUND_COMPLETE,onPlayComplete);
				sndChannel.stop();
			}
			numSndPosition = 0;
			isPlaying = false;
			// Stop the all sounds //
			SoundMixer.stopAll();
		}
		
		//--------------------------------------------------------------------------
		//  Method:showLargePic
		//  Expranation: show the large picture
		//	Parameter: 	
		//--------------------------------------------------------------------------	
		private function showLargePic():void
		{
			//** Move the object on the selected object **//
			//stopSound();
			//* Hide another large pictures *//
			for(var intObj:int=0; intObj<sprParent.numChildren; intObj++)
			{
				var strName:String = sprParent.getChildAt(intObj).name;
				if(strName.indexOf(KEY_LARGE_PIC)!=-1)
				{
					var obj = sprParent.getChildAt(intObj);
					obj.visible = false;
				}						
			}			
			sprParent.setChildIndex(objLargeMovieClip,sprParent.numChildren-1);	//move front
			objLargeMovieClip.visible = true;
		}
		
		//--------------------------------------------------------------------------
		//  Method:hideLargePic
		//  Expranation: hide the large picture
		//	Parameter: 	
		//--------------------------------------------------------------------------	
		private function hideLargePic(event:Event):void
		{
			//** Hide the object **//
			stopSound();
			var obj = event.target;
			obj.visible = false;
		}		
	}
}
